*
* Les passagers du vent
*
* (c) 1986, Infogrames
* (c) 1988, Ordigrames
* (c) 2021, Brutal Deluxe Software
*

	mx	%00
	rel
	lst	off

*--------------------------

nbREPLAY	=	1000	; number of possible replay steps
GSOS	=	$e100a8

*--------------------------

	use	4/Event.Macs
	use	4/Int.Macs
	use	4/Locator.Macs
	use	4/Mem.Macs
	use	4/Menu.Macs
	use	4/MIDISyn.Macs
	use	4/Misc.Macs
	use	4/QD.Macs
	use	4/SANE.Macs
	use	4/Sound.Macs
	use	4/Std.Macs
	use	4/Text.Macs
	use	4/Util.Macs
	
*--------------------------

	phk
	plb

         STA   theA
         STX   theX
         STY   theY

	tdc
	sta	myDP
	
         PEA   ^L030028	; init the APW library
         PEA   L030028
         JSL   L014D37
         PLY
         PLY
         TAY
         BNE   L010097	; always always 0...

         LDX   L020004	; let's go the main program
         LDA   L020002
         PHX
         PHA
         LDA   L020000
         PHA
         JSL   main
         PLY
         PLY
         PLY

L010097  JSL   GSOS
         DW    $0029      ; Quit
         ADRL  L030000

         brk   $bd

*-----------------------------------
* COPY BACKGROUND
*-----------------------------------

* $F9: pointer to source rect
* $FD: pointer to pixel image

copyBACKGROUND
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00EA
         TCS

         LDY   #$0006	; calculate X2
         LDA   [$F9],Y
         SEC
         LDY   #$0002
         sbc   [$F9],Y
         STA   $EE

         LDY   #$0004	; calculate Y2
         LDA   [$F9],Y
         SEC
         sbc   [$F9]
         STA   $EC

         stz   lisPortSCB
	
         PEA   ^destRect	; pointer to rectangle
         PEA   destRect
         PEA   $0000	; X1
         PEA   $0000	; Y1
         PEI   $EE	; X2
         PEI   $EC	; Y2
         _SetRect

         LDA	$EE	; X2
	and	#$0008
	beq	noBIT32
	lda	$ee
	clc
	adc	#7
	lsr
	lsr
	lsr
	bra	hophop2
noBIT32	lda	$ee
	clc
	adc	#15
	lsr
	lsr
	lsr
	lsr
	asl
hophop2	asl
	asl
	sta	lisWidth

         LDA   $FF
         STA   lisPixImage+2
         LDA   $FD
         STA   lisPixImage

         LDA   theGRAFPORT+2
         STA   ptrToSrcLocInfo+2
         LDA   theGRAFPORT
         STA   ptrToSrcLocInfo

         LDA   #lisPortSCB
         STA   ptrToDestLocInfo
         LDA   #^lisPortSCB
         STA   ptrToDestLocInfo+2

         LDA   $FB
         STA   ptrToSourceRect+2
         LDA   $F9
         STA   ptrToSourceRect

         LDA   #destRect
         STA   ptrToDestPoint
         LDA   #^destRect
         STA   ptrToDestPoint+2

         stz   ppMode	; mode copy

         stz   maskHandle+2
         stz   maskHandle

         _HideCursor
         PEA   ^paintParam
         PEA   paintParam
         _PaintPixels

         _ShowCursor

         TDC
         CLC
         ADC   #$00F3
         TCS
         PLD
         RTL

*-----------------------------------
* DRAW IMAGE
*-----------------------------------
* drawIMAGE(*image, *rectangle)
*
* $EC: word - bottom
* $EE: word - right
* $F0: long - 
* $F2: wo
* $F9: long - pointer to rectangle
* $FD: long - pointer to source image

drawIMAGE
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00EA
         TCS

         LDY   #$0006
         LDA   [$F9],Y
         LDY   #$0002	; widthX - destX
         SEC
         SBC   [$F9],Y
         STA   $EE

         LDY   #$0004
         LDA   [$F9],Y
         SEC
         SBC   [$F9]	; widthY - destY
         STA   $EC

         stz   locPtr	; portSCB
	
         PEA   ^locRect	; long - theRECTANGLES+4
         PEA   locRect
         PEA   $0000	; word - left
         PEA   $0000	; word - top
         PEI   $EE	; word - right
         PEI   $EC	; word - bottom
         _SetRect

         LDA	$EE	; X2
	and	#$0008
	beq	noBIT33
	lda	$ee
	clc
	adc	#7
	lsr
	lsr
	lsr
	bra	hophop3
noBIT33	lda	$ee
	clc
	adc	#15
	lsr
	lsr
	lsr
	lsr
	asl
hophop3	asl
	asl
	sta	locWidth

         lda   $FF	; pointer to source image
         STA   locImage+2
         LDA   $FD
         STA   locImage

         PEA   ^locPtr	; long - locPtr
         PEA   locPtr
         PEA   ^locRect	; long - locRect
         PEA   locRect

         LDY   #$0002
         LDA   [$F9],Y
         PHA		; word - destX
         LDA   [$F9]
         PHA		; word - destY
         PEA   $0000	; word - transferMode (modeCopy)
         _PPToPort	; draw the image

         TDC
         CLC
         ADC   #$00F3
         TCS
         PLD
         RTL

*-----------------------------------
* SHOW IMAGE (THE STRIP)
*-----------------------------------

showIMAGE
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS
         LDX   haHANDLE+2
         LDA   haHANDLE
         STA   $F8
         STX   $FA
         LDY   #$0002	; dereference handle
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         PHX
         PHA
         PEA   ^L03020A
         PEA   L03020A
         JSL   drawIMAGE
         PLY
         PLY
         PLY
         PLY
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* SHOW ICON (THE LOWER LEFT ICON)
*-----------------------------------

showICON
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS
         LDX   haBACKGROUND+2
         LDA   haBACKGROUND
         STA   $F8
         STX   $FA
         LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         PHX
         PHA
         PEA   ^L03021A
         PEA   L03021A
         JSL   drawIMAGE
         PLY
         PLY
         PLY
         PLY
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* SAVE ICON (THE LOWER LEFT ICON)
*-----------------------------------

saveICON
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS
         LDX   haBACKGROUND+2
         LDA   haBACKGROUND
         STA   $F8
         STX   $FA
         LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         PHX
         PHA
         PEA   ^L03021A
         PEA   L03021A
         JSL   copyBACKGROUND
         PLY
         PLY
         PLY
         PLY
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* PAINT THE DIALOG RECTANGLE
*-----------------------------------

paintRIGHTRECT
	PushLong #L030222
         _PaintRect
	rtl

*-----------------------------------
* SHOW MENU BAR
*-----------------------------------

showMENUBAR
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS
         LDA   #$0001
         STA   fgMENUBAR
         LDX   haMENUBAR+2
         LDA   haMENUBAR
         STA   $F8
         STX   $FA
         LDY   #$0002
         LDA   [$F8],Y
         pha
         LDA   [$F8]
         pha
         PEA   ^L03022A
         PEA   L03022A
         JSL   copyBACKGROUND
         PLY
         PLY
         PLY
         PLY
         _DrawMenuBar
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* HIDE MENU BAR
*-----------------------------------

hideMENUBAR
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS
         STZ   fgMENUBAR
         LDX   haMENUBAR+2
         LDA   haMENUBAR
         STA   $F8
         STX   $FA
         LDY   #$0002
         LDA   [$F8],Y
         pha
         LDA   [$F8]
         PHA
         PEA   ^L03022A
         PEA   L03022A
         JSL   drawIMAGE
         PLY
         PLY
         PLY
         PLY
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* PRINT CHAR
*-----------------------------------

printCHAR
	and	#$00ff
	pha
	_DrawChar
	lda	coordX
	clc
	adc	#8
	sta	coordX
	rtl
	
*-----------------------------------
* PRINT TEXT
*-----------------------------------
* printTEXT(mode, index)
* $F1: byte
* $F2: byte
* $F4: long
*
* $FD: word (string index)
* $FF: word (0000/0001)

* A text file
* 00.04: header
* a string:
*  00: 1F: beginning of string, 1B: beginning of answer
*  01: X-coord, minus 3F
*  02: Y-coord, minus 41
*  xx: 7F: end of string

printTEXT
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00EB
         TCS
         SEP   #$20
         STZ   $F1
         REP   #$20
         LDA   $FF	; if mode 0
         AND   #$00FF
         BNE   L0109A7
         LDA   $FD	; and index 0
         AND   #$00FF
         BNE   L0109AB
L0109A7  jsl   paintRIGHTRECT	; paint rect, also if mode <> 0
				; and exit
L0109AB  LDA   $FD		; string index <> 0, go
         AND   #$00FF
         BNE   L0109B5
         BRL   L010B78
L0109B5  PEA   $000F
	_SetForeColor

         LDA   $FD	; string index
         AND   #$00FF
         SEC
         SBC   #$00C8	; minus 200
         BVS   L0109CB
         EOR   #$8000
L0109CB  BMI   L0109DB
         LDX   ptrTXT+2	; set the pointer to the next
         LDA   ptrTXT
         STX   $EF
         STA   $ED
         DEC   $FD
         BRA   L0109F4

L0109DB  LDX   ptrTEXT+2
         LDA   ptrTEXT
         STX   $EF
         STA   $ED
         LDA   $FD
         AND   #$00FF
         SEC
         SBC   #$00C8
         SEP   #$20
         STA   $FD
         REP   #$20

L0109F4  STZ   $F2	; x=0
         BRA   L010A14

L0109F8  LDX   $EF	; action 1. search for the first end string
         LDA   $ED
         INC   $ED
         BNE   L010A02
         INC   $EF
L010A02  STA   $F4
         STX   $F6
         LDA   [$F4]
         AND   #$00FF
         CMP   #$007F	; end of string
         bne   L0109F8
         INC   $F2
L010A14  LDA   $FD
         AND   #$00FF
         SEC
         SBC   $F2
         BEQ   L010A25
         BVS   L010A23
         EOR   #$8000
L010A23  BMI   L0109F8

L010A25  LDA   [$ED]
         AND   #$00FF
         CMP   #$007F	; end of string
         bne   L010A3F
         LDA   #$0001
         SEP   #$20
         STA   $F1	; end of string found
         REP   #$20
         BRL   L010B6E

L010A3F  CMP   #$001F	; beginning of string
         BEQ   L010A47
         BRL   L010AC3

L010A47  INC   $ED	; go to next char
         BNE   L010A4D
         INC   $EF
L010A4D  LDA   #$0008
         PHA
	lda	[$ed]
         AND   #$00FF
         SEC
         SBC   #$003F
         SEC
         JSL   multiply16BIT
	inc	$ed
	bne	L01PLUS
	inc	$ef
L01PLUS
         PLA
         STA   coordY

         LDA   #$0008
         PHA
	lda	[$ed]
         AND   #$00FF
         SEC
         SBC   #$0041
         SEC
         JSL   multiply16BIT
	inc	$ed
	bne	L02PLUS
	inc	$ef
L02PLUS
         PLA
         STA   coordX
         STA   oldX
         PHA
         LDA   coordY
         SEC
         SBC   #$0002
         CLC
         ADC   offsetY
         PHA
         _MoveTo
         BRL   L010B6E

L010AC3  CMP   #$000D	; carriage return
         bne   L010B08
         INC   $ED
         BNE   L010AD0
         INC   $EF

L010AD0  LDA   coordY
         CLC
         ADC   #8
         STA   coordY
         LDA   oldX
         STA   coordX
         PHA

         LDA   coordY
         SEC
         SBC   #$0002
         CLC
         ADC   offsetY
         PHA
         _MoveTo
         bra   L010B6E

L010B08  CMP   #$001B	; Choix en mettant la couleur marron
         bne   L010B26
         INC   $ED
         BNE   L010B16
         INC   $EF
L010B16  PEA   $0001
         _SetForeColor
         INC   $ED
         BNE   L010B24
         INC   $EF
L010B24  BRA   L010B6E

L010B26  sep	#$30
	lda	[$ed]
	bpl	printIT
	and	#$7f
	tax
patchLANGUE
	lda	tblFR,x
printIT	rep	#$30
	pha
	_DrawChar
	
	lda	coordX
	clc
	adc	#8
	sta	coordX

	inc	$ed
	bne	L010B6E
	inc	$ef

L010B6E  LDA   $F1	; did we reach the end of string?
         AND   #$00FF
         BNE   L010B78
         BRL   L010A25	; no, loop
L010B78  TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* UNPACK IMAGE
*-----------------------------------
*
* $EF: num image
* $F1: long haPICTURE
* $F5: long haPICTURE2
* $F9: long $E6
* $FD: long $E4

unpackIMAGE
         PHD
         TSC
         SEC
         SBC   #$00E9
         TCD
         ADC   #$00CD
         TCS

	ldy	#2	; dereference handle
	lda	[$f1],y
	sta	$e0
	lda	[$f1]
	sta	$de
	
	lda	[$de]
	cmp	#'CM'
	bne	withinGIM
	brl	L010BB3

*--- The image is within a GIM file (ie. 320x200)

withinGIM
	ldy	#$14
	lda	[$de],y
	xba
	sta	picWIDTH	; the width
	sta	picWIDTH2

	and	#$0008
	beq	noBIT30
	
*--- Cas d'une image de largeur finissant par 8
	
	lda	picWIDTH	; output on 8x width only
	clc
	adc	#7
	lsr
	lsr
	lsr
	asl
	asl
	sta	IFFwidth2

	lda	picWIDTH	; for 8x pics, add 8 to the width!
	clc
	adc	#8
	sta	picWIDTH
	clc
	adc	#7	; +15 au total
	lsr
	lsr
	lsr
	lsr
	asl
	asl
	asl
	sta	IFFwidth
	bra	hophop0
	
*--- Cas d'une image de largeur finissant par 0

noBIT30	lda	picWIDTH
	clc
	adc	#15
	lsr
	lsr
	lsr
	lsr
	asl
	asl
	asl
	sta	IFFwidth
	sta	IFFwidth2

*---

hophop0	
	ldy	#$16
	lda	[$de],y
	xba
	sta	picHEIGHT	; the height
	
	ldy	#$1c
	lda	[$de],y
	and	#$ff
	sta	picPLANES	; number of planes

	ldy	#$1e
	lda	[$de],y
	and	#$ff
	sta	picCOMPRESS	; pic is compressed or not
	
	ldy	#$30	; read/prepare the palette
	jsr	doPALETTE

	ldy	#$a8	; body begins at $a8
	brl	doBODY

*--- The image is within a BTM file...
* Palette at +$08
* Offset  at +$40 (long big endian)
* Body   at +$100 (add offset)

L010BB3
	ldy	#$08
	jsr	doPALETTE
	
	lda	$ef
	and	#$00ff
	asl
	asl
	clc
	adc	#$40	; offset to the OFFS chunk
	tay
	lda	[$de],y
	xba
	sta	picOFFSET+2
	iny
	iny
	lda	[$de],y
	xba
	sta	picOFFSET
	
	clc		; calculate offset to body
	adc	#$0100	; body of pic
	sta	picOFFSET
	lda	picOFFSET+2
	adc	#0
	sta	picOFFSET+2

	lda	$de	; calculate pointer to body
	clc
	adc	picOFFSET
	sta	$de
	lda	$e0
	adc	picOFFSET+2
	sta	$e0
	
	ldy	#$0c
	lda	[$de],y
	xba
	sta	picWIDTH		; the width that can be modified
	sta	picWIDTH2	; the real width

	and	#$0008
	beq	noBIT31

*--- Cas d'une image de largeur finissant par 8
	
	lda	picWIDTH	; output on 8x width only
	clc
	adc	#7
	lsr
	lsr
	lsr
	asl
	asl
	sta	IFFwidth2

	lda	picWIDTH	; for 8x pics, add 8 to the width!
	clc
	adc	#8
	sta	picWIDTH
	clc
	adc	#7	; +15 au total
	lsr
	lsr
	lsr
	lsr
	asl
	asl
	asl
	sta	IFFwidth
	bra	hophop1
	
*--- Cas d'une image de largeur finissant par 0

noBIT31	lda	picWIDTH
	clc
	adc	#15
	lsr
	lsr
	lsr
	lsr
	asl
	asl
	asl
	sta	IFFwidth
	sta	IFFwidth2

*---

hophop1	ldy	#$0e
	lda	[$de],y
	xba
	sta	picHEIGHT	; the height
	
	ldy	#$14
	lda	[$de],y
	and	#$ff
	sta	picPLANES	; number of planes

	ldy	#$16
	lda	[$de],y
	and	#$ff
	sta	picCOMPRESS	; pic is compressed or not

	ldy	#$28
	
*---

doBODY	tya		; we point to the body data
	clc
	adc	$de
	sta	unpIFF50+1
	sta	unpIFF60+1
	sta	unpIFF61+1
	sta	unpIFF71+1
	lda	#0
	adc	$e0
	sep	#$20
	sta	unpIFF50+3
	sta	unpIFF60+3
	sta	unpIFF61+3
	sta	unpIFF71+3
	rep	#$20

*--- Ask for RAM

	pha		; 1 - space for result
	pha

	pha
	pha
	PushWord	IFFwidth
	PushWord picHEIGHT
	_Multiply
	
	lda	1,s
	sta	picSIZE
	
	LDA	myID	; 3
	PHA
	PEA	$8010	; 4
	PEA	$0000	; 5
	PEA	$0000
	_NewHandle
	pla
	sta	[$f5]	; save to haPICTURE2
	sta	$e6
	pla
	ldy	#2
	sta	[$f5],y
	sta	$e8

	ldy	#2	; dereference handle
	lda	[$e6],y
	tax
	lda	[$e6]
	sta	$e6
	stx	$e8	; pointer to the destination buffer

*--- Now, unpack

	stz	numLIGNE	; we'll unpack at line 0
	
         ldx	#0
	txy
	sep	#$20
	
         lda	picCOMPRESS	; 0 = uncompressed
         bne	unpIFF60		; 1 = compressed

*- Image non compressee ILBM

unpIFF50	ldal	$bdbdbd,x
	inx
	sta	tempTABLE,y
	iny
	cpy	IFFwidth
	bcc	unpIFF50
	jsr	planes2bytes
	bcc	unpIFF50
	brl	unpackEND

*- Image compressee ILBM (1-8 plans)

unpIFF60 ldal	$bdbdbd,x
	inx
	cmp	#$80
	beq	unpIFF60
         cmp	#$81
         bcc	unpIFF70

         eor	#$ff
         inc
         sta	IFFcnt
unpIFF61 ldal	$bdbdbd,x
	inx
]lp	sta	tempTABLE,y
	iny
	dec	IFFcnt
	bpl	]lp
	cpy	IFFwidth
	bcc	unpIFF60
youpi	jsr	planes2bytes
	bcc	unpIFF60
	brl	unpackEND

unpIFF70 sta	IFFcnt
unpIFF71 ldal	$bdbdbd,x
	inx
	sta	tempTABLE,y
	iny
	dec	IFFcnt
	bpl	unpIFF71
	cpy	IFFwidth
	bcc	unpIFF60
	jsr	planes2bytes
	bcc	unpIFF60
	brl	unpackEND

*---

planes2bytes
	phx
	lda	#%0000_0001
         sta	IFFpmask
         stz	IFFplanes

	ldx	picWIDTH		; clear the 8-bit line
]lp	dex
	stz	tempTABLE2,x
	bpl	]lp
	
         ldx   #0
unpIFFy2 ldy   #0
unpIFFy3 lda   tempTABLE,x
         and   #%1000_0000
         beq   unpIFFy4
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy4 iny
         lda   tempTABLE,x
         and   #%0100_0000
         beq   unpIFFy5
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy5 iny
         lda   tempTABLE,x
         and   #%0010_0000
         beq   unpIFFy6
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy6 iny
         lda   tempTABLE,x
         and   #%0001_0000
         beq   unpIFFy7
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy7 iny
         lda   tempTABLE,x
         and   #%0000_1000
         beq   unpIFFy8
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy8 iny
         lda   tempTABLE,x
         and   #%0000_0100
         beq   unpIFFy9
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy9 iny
         lda   tempTABLE,x
         and   #%0000_0010
         beq   unpIFFy10
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy10 iny
         lda   tempTABLE,x
         and   #%0000_0001
         beq   unpIFFy11
         lda   tempTABLE2,y
         ora   IFFpmask
         sta   tempTABLE2,y
unpIFFy11 iny
         inx
         cpx   IFFwidth
         bcs   unpIFFy13
         cpy   picWIDTH
         bcs   unpIFFy12
         brl   unpIFFy3
unpIFFy12 asl  IFFpmask
         inc   IFFplanes
         lda   IFFplanes
         cmp   picPLANES	; 4
         bcs   unpIFFy13
         brl   unpIFFy2

unpIFFy13		; 8-bit to 4-bit pixels
	ldx	#0
	txy
]lp	lda	tempTABLE2,x
	asl
	asl
	asl
	asl
	ora	tempTABLE2+1,x
	sta	[$e6],y
	inx
	inx
	iny
	cpy	IFFwidth2	; copy until real right
	bcc	]lp

	rep	#$20
		
	inc	numLIGNE
         lda	numLIGNE
         cmp	picHEIGHT
         bcs	unpIFFy14

	lda	$e6
	clc
	adc	IFFwidth2
	sta	$e6
	lda	$e8
	adc	#0
	sta	$e8
	plx
	ldy	#0
         clc
	sep	#$20	; could have changed C as well
         rts
unpIFFy14 plx
	sec
	sep	#$20
         rts

*--- From a PC palette to a IIgs palette

	mx	%00
	
doPALETTE
         ldx   #0

]lp      lda   [$de],y	; pcPALETTE,x
	asl
	asl
	asl
	asl
	and   #$0f00
	pha

	iny
         lda   [$de],y	; pcPALETTE+1,x
	and   #$00f0
         ora   1,s
         sta   1,s

	iny
         lda   [$de],y	; pcPALETTE+2,x
	lsr
	lsr
	lsr
	lsr
         and   #$000f
         ora   1,s
         sta   palLEVEL1,x	; [dpPAL],y

         pla
         iny

         inx
         inx
	cpx	#32
	bcc	]lp
         rts

*--- Return

	mx	%10	; on entry
unpackEND
	rep	#$20
	
	lda	picHEIGHT
	sta	[$f9]
	
	lda	picWIDTH2	; return the real width
	sta	[$fd]

         TDC
         CLC
         ADC   #$00E9
         TCS
         PLD
         RTL

*-----------------------------------
* SHOW PICTURE
*-----------------------------------
* showPICTURE(imageIndex, x1, y1, fgDispose)
*
* $F9: 0002 - 0001 - image number
* $FB: 0000 - 0000 - X1
* $FD: 0090 - 0000 - Y1
* $FF: 0000 - 0001 - dispose handle if non zero

*         PEA   $0001
*         PEA   $0000
*         PEA   $0000
*         PEA   $0001

*         PEA   $0000
*         PEA   $0090
*         PEA   $0000
*         PEA   $0002

showPICTURE
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00E2
         TCS

         PEA   $0000
         TDC
         CLC
         ADC   #$00E4
         PHA

         PEA   $0000
         TDC
         CLC
         ADC   #$00E6
         PHA

         PEA   ^haPICTURE2
         PEA   haPICTURE2

         LDX   haPICTURE+2
         LDA   haPICTURE
         PHX
         PHA
         LDA   $F9	; num image
         SEC
         SBC   #$0001
         PHA
         JSL   unpackIMAGE
         TAY
         TSC
         CLC
         ADC   #$0012
         TCS
         TYA

         PEA   $0000
         TDC
         CLC
         ADC   #$00E8
         PHA

         PEI   $FB	; X1
         PEI   $FD	; Y1

         LDA   $E4	; no more multiply Y
         clc
         adc   $FB
         PHA		; X2

         LDA   $FD
         CLC
         ADC   $E6
         PHA		; Y2
         _SetRect

         LDA   fgMENUBAR
         BEQ   L01117A
         JSL   hideMENUBAR

L01117A  LDA   $FF
         BEQ   L011182
         JSL   fadeTOPALETTE

L011182  LDX   haPICTURE2+2	; dereference handle
         LDA   haPICTURE2
         STA   $F0
         STX   $F2
         LDY   #$0002	; show the picture, please
         LDA   [$F0],Y
         TAX
         LDA   [$F0]
         PHX
         PHA
         PEA   $0000
         TDC
         CLC
         ADC   #$00E8
         PHA
         JSL   drawIMAGE
         PLY
         PLY
         PLY
         PLY

         LDA   $FF	; shall we get rid of the handle?
         BNE   L0111BD
         LDX   haPICTURE2+2
         LDA   haPICTURE2
         PHX
         PHA
         _DisposeHandle
L0111BD  TDC
         CLC
         ADC   #$00F3
         TCS
         PLD
         RTL

*-----------------------------------
* LOAD FILE
*-----------------------------------

loadFILE
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00E0
         TCS
         PEA   $0001
         PEI   $FB
         PEI   $F9
         JSL   openDATA
         PLY
         PLY
         PLY
         STA   $EE
*         LDX   #$0000
*         LDA   #$0000
*         PHX
*         PHA
	pea	$0000
	pea	$0000
*         LDA   $EE
         LDX   #$0000
         lda   $ee
         BPL   L0111F1
         DEX
L0111F1  JSL   subtract32BIT
         BNE   L0111FA
         BRL   L011281
L0111FA  PEA   $0002
         PEA   $0000
         PEA   $0000
         PEI   $EE
         JSL   L015418
         PLY
         PLY
         PLY
         PLY
         STX   $EC
         STA   $EA
         PEA   $0000
         PEA   $0000
         PEA   $0000
         PEI   $EE
         JSL   L015418
         PLY
         PLY
         PLY
         PLY
         PHX
         PHA
         PEI   $EC
         PEI   $EA
         LDA   myID
         PHA
         PEA   $8000
         PEA   $0000
         PEA   $0000
         _NewHandle
	pla
	sta	[$fd]
	pla
	ldy	#2
	sta	[$fd],y

	lda	$ec	; data can be >64k
	sta	patchREAD+1
	
         LDA   $EA
         PHA
         LDY   #$0002
         LDA   [$FD],Y
	sta   $f2
         LDA   [$FD]
         STA   $F0
         LDY   #$0002
         LDA   [$F0],Y
         pha
         LDA   [$F0]
         PHA
         PEI   $EE
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         STA   $E6
         PEI   $EE
         JSL   L015652
         PLY
         BRA   L011285
L011281  JSL   doINSERTAUTHORIZEDDISK
L011285  LDA   $E6
         TAY
         TDC
         CLC
         ADC   #$00F3
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* DIALOG AUTHORIZED DISK
*-----------------------------------

doINSERTAUTHORIZEDDISK
	PHD
	TSC
	SEC
	SBC   #$00FB
	TCD
	ADC   #$00F6
	TCS
         PEA   ^L030655
         PEA   L030655
         JSL   showDIALOG
         PLY
         PLY
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL
         RTL

*-----------------------------------
* SAVE THE PARTY FILE
*-----------------------------------

saveSAUVE
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F4
         TCS

	sep	#$30	; make it a C string
	ldx	loadPATH
	stz	loadPATH1,x
	rep	#$30
	
         PEA   $0122	; 290
	PushLong #loadPATH1
         JSL   L01557A	; create file
         PLY
         PLY
         PLY
*         STA   $F6
*         PEI   $F6
	pha
         JSL   L015652	; close?
         PLY
         PEA   $0022	; 34 = 324
	PushLong #loadPATH1
         JSL   openDATA	; open file
         PLY
         PLY
         PLY
         STA   $F6
         CMP   #$FFFF
         BNE   L011307
         BRL   L0113BB

L011307  PEA   $0100	; write 256 (the conditions)
         PEA   ^tblCONDITIONS
         PEA   tblCONDITIONS
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0001	; write 1 / 257
         PEA   ^fgTALKING
         PEA   fgTALKING
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0001	; write 1 / 258
         PEA   ^theLEVEL
         PEA   theLEVEL
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0001	; write 1 / 259
         PEA   ^curCHAR
         PEA   curCHAR
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0050	; write 80 / 339
         PEA   ^L032FD7
         PEA   L032FD7
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002	; write 2 / 341
         PEA   ^L02008A
         PEA   L02008A
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002	; write 2 / 343
         PEA   ^L02008C
         PEA   L02008C
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002	; write 2 / 345
         PEA   ^L02008E
         PEA   L02008E
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002	; write 2 / 347
         PEA   ^L020090
         PEA   L020090
         PEI   $F6
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PEI   $F6
         JSL   L015652	; close file
         PLY
         BRA   L0113BF

L0113BB  JSL   doINSERTAUTHORIZEDDISK

L0113BF  TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* LOAD THE PARTY FILE
*-----------------------------------

loadSAUVE
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F4
         TCS

	sep	#$30	; make it a C string
	ldx	loadPATH
	stz	loadPATH1,x
	rep	#$30
	
         PEA   $0021
	PushLong #loadPATH1
         JSL   openDATA
         PLY
         PLY
         PLY
         STA   $F6
         CMP   #$FFFF
         BNE   L0113EE
         BRL   L0114A9

L0113EE	stz	patchREAD+1	; we'll never read >64K here

         PEA   $0100
         PEA   ^tblCONDITIONS
         PEA   tblCONDITIONS
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0001
         PEA   ^fgTALKING
         PEA   fgTALKING
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0001
         PEA   ^theLEVEL
         PEA   theLEVEL
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0001
         PEA   ^curCHAR
         PEA   curCHAR
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0050
         PEA   ^L032FD7
         PEA   L032FD7
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002
         PEA   ^L02008A
         PEA   L02008A
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002
         PEA   ^L02008C
         PEA   L02008C
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002
         PEA   ^L02008E
         PEA   L02008E
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEA   $0002
         PEA   ^L020090
         PEA   L020090
         PEI   $F6
         JSL   readDATA
         PLY
         PLY
         PLY
         PLY
         PEI   $F6
         JSL   L015652
         PLY
         JSL   createBACKUPLEVEL
         STZ   replaySTEP
         BRA   L0114AD
L0114A9  JSL   doINSERTAUTHORIZEDDISK
L0114AD  TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* CALC OFFSET
*-----------------------------------
* Return an offset from (index x $100) + offset
* $FD: word - offset to index
* $FF: word - index (index x $100)

calcOFFSET
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         AND   #$00FF
         PHA
         LDA   $FF
         AND   #$00FF
         PHA
         LDA   #$0100
         SEC
         JSL   multiply16BIT
         PLA
         PLX
         STX   $F4
         CLC
         ADC   $F4
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* LOGO
*-----------------------------------
*
* $FB
* $FD
* $FF

L0114E5  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00E8
         TCS
         LDX   ptrSTR2+2
         LDA   ptrSTR2
         STX   $F4
         STA   $F2
         LDA   $FF
         BEQ   L011504
         BRL   L011582
L011504  STZ   $EE
         BRA   L011570
L011508  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011512
         INC   $F4
L011512  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EE
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L032FD7,X
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011534
         INC   $F4
L011534  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EE
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L032FD8,X
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011556
         INC   $F4
L011556  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EE
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L032FD9,X
         REP   #$20
         INC   $EE
L011570  LDA   $EE
         SEC
         SBC   #$0014
         BVS   L01157B
         EOR   #$8000
L01157B  BPL   L011508
         BRL   L011D2F
         BRA   L01158A
L011582  CMP   #$0001
         BEQ   L01158A
         BRL   L011742
L01158A  STZ   $EE
         BRL   L011722
L01158F  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011599
         INC   $F4
L011599  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EE
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         PLA
         SEP   #$20
         STA   L03099D,X
         REP   #$20
         STZ   $EC
         BRA   L011603
L0115BD  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L0115C7
         INC   $F4
L0115C7  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         PHA
         LDA   $EE
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L03099E
         STA   $F6
         LDA   #^L03099E
         BCC   L0115EE
         INC
L0115EE  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L0115FA
         INC   $F8
L0115FA  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EC
L011603  LDA   $EC
         SEC
         SBC   #$0005
         BVS   L01160E
         EOR   #$8000
L01160E  BPL   L0115BD
         STZ   $EC
         BRA   L011688
L011614  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L01161E
         INC   $F4
L01161E  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011637
         INC   $F4
L011637  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F0
         REP   #$20
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $F1
         AND   #$00FF
         PHA
         JSL   calcOFFSET
         PLY
         PLY
         PHA
         LDA   $EC
         ASL
         PHA
         LDA   $EE
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L0309A3
         STA   $F6
         LDA   #^L0309A3
         BCC   L011677
         INC
L011677  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011683
         INC   $F8
L011683  PLA
         STA   [$F6]
         INC   $EC
L011688  LDA   $EC
         SEC
         SBC   #$0005
         BVS   L011693
         EOR   #$8000
L011693  BMI   L011698
         BRL   L011614

L011698  STZ   $EC
         BRA   L011710

L01169C  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L0116A6
         INC   $F4
L0116A6  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L0116BF
         INC   $F4
L0116BF  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F0
         REP   #$20
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $F1
         AND   #$00FF
         PHA
         JSL   calcOFFSET
         PLY
         PLY
         PHA
         LDA   $EC
         ASL
         PHA
         LDA   $EE
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L0309AD
         STA   $F6
         LDA   #^L0309AD
         BCC   L0116FF
         INC
L0116FF  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L01170B
         INC   $F8
L01170B  PLA
         STA   [$F6]
         INC   $EC
L011710  LDA   $EC
         SEC
         SBC   #$0005
         BVS   L01171B
         EOR   #$8000
L01171B  BMI   L011720
         BRL   L01169C

L011720  INC   $EE
L011722  lda   #5
*	LDA   theLEVEL
*         AND   #$00FF
*         ASL
*         TAX
*         LDA   L0308F5,X
         SEC
         SBC   $EE
         BEQ   L01173D
         BVS   L011738
         EOR   #$8000
L011738  BPL   L01173D
         BRL   L01158F
L01173D  BRL   L011D2F
         BRA   L01174A

L011742  CMP   #$0002
         BEQ   L01174A
         BRL   L011919
L01174A  STZ   $EE
         BRL   L011904
L01174F  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011759
         INC   $F4
L011759  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011772
         INC   $F4
L011772  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F0
         REP   #$20
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $F1
         AND   #$00FF
         PHA
         JSL   calcOFFSET
         PLY
         PLY
         PHA
         LDA   $EE
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         PLA
         STA   theRECTANGLES,X
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L0117B0
         INC   $F4
L0117B0  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L0117C9
         INC   $F4
L0117C9  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F0
         REP   #$20
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $F1
         AND   #$00FF
         PHA
         JSL   calcOFFSET
         PLY
         PLY
         PHA
         LDA   $EE
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         PLA
         STA   theRECTANGLES+2,X
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011807
         INC   $F4
L011807  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011820
         INC   $F4
L011820  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F0
         REP   #$20
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $F1
         AND   #$00FF
         PHA
         JSL   calcOFFSET
         PLY
         PLY
         PHA
         LDA   $EE
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         PLA
         STA   theRECTANGLES+4,X
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L01185E
         INC   $F4
L01185E  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011877
         INC   $F4
L011877  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F0
         REP   #$20
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $F1
         AND   #$00FF
         PHA
         JSL   calcOFFSET
         PLY
         PLY
         PHA
         LDA   $EE
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         PLA
         STA   theRECTANGLES+6,X
         STZ   $EC
         BRA   L0118F5
L0118AF  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L0118B9
         INC   $F4
L0118B9  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         PHA
         LDA   $EE
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #theRECTANGLES2
         STA   $F6
         LDA   #^theRECTANGLES2
         BCC   L0118E0
         INC
L0118E0  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L0118EC
         INC   $F8
L0118EC  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EC
L0118F5  LDA   $EC
         SEC
         SBC   #$0005
         BVS   L011900
         EOR   #$8000
L011900  BPL   L0118AF
         INC   $EE
L011904  LDA   $EE
         SEC
         SBC   #$000C
         BVS   L01190F
         EOR   #$8000
L01190F  BMI   L011914
         BRL   L01174F
L011914  BRL   L011D2F
         BRA   L011921
L011919  CMP   #$0003
         BEQ   L011921
         BRL   L011D2F
L011921  STZ   $EE
         BRL   L011D0C
L011926  STZ   $EC
         BRA   L011970
L01192A  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011934
         INC   $F4
L011934  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AC7
         STA   $F6
         LDA   #^L030AC7
         BCC   L01195B
         INC
L01195B  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011967
         INC   $F8
L011967  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EC
L011970  LDA   $EC
         SEC
         SBC   #$0005
         BVS   L01197B
         EOR   #$8000
L01197B  BPL   L01192A
         STZ   $EC
         BRA   L0119DE
L011981  STZ   $EA
         BRA   L0119CF
L011985  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L01198F
         INC   $F4
L01198F  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         ASL
         CLC
         ADC   $EA
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ACC
         STA   $F6
         LDA   #^L030ACC
         BCC   L0119BA
         INC
L0119BA  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L0119C6
         INC   $F8
L0119C6  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EA
L0119CF  LDA   $EA
         SEC
         SBC   #$0002
         BVS   L0119DA
         EOR   #$8000
L0119DA  BPL   L011985
         INC   $EC
L0119DE  LDA   $EC
         SEC
         SBC   #$0002
         BVS   L0119E9
         EOR   #$8000
L0119E9  BPL   L011981
         STZ   $EC
         BRL   L011A7E
L0119F0  STZ   $EA
         BRA   L011A6C
L0119F4  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L0119FE
         INC   $F4
L0119FE  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011A17
         INC   $F4
L011A17  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F0
         REP   #$20
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $F1
         AND   #$00FF
         PHA
         JSL   calcOFFSET
         PLY
         PLY
         PHA
         LDA   $EC
         ASL
         CLC
         ADC   $EA
         ASL
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AD0
         STA   $F6
         LDA   #^L030AD0
         BCC   L011A5B
         INC
L011A5B  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011A67
         INC   $F8
L011A67  PLA
         STA   [$F6]
         INC   $EA
L011A6C  LDA   $EA
         SEC
         SBC   #$0002
         BVS   L011A77
         EOR   #$8000
L011A77  BMI   L011A7C
         BRL   L0119F4
L011A7C  INC   $EC
L011A7E  LDA   $EC
         SEC
         SBC   #$0002
         BVS   L011A89
         EOR   #$8000
L011A89  BMI   L011A8E
         BRL   L0119F0
L011A8E  STZ   $EC
         BRA   L011AD8
L011A92  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011A9C
         INC   $F4
L011A9C  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AD8
         STA   $F6
         LDA   #^L030AD8
         BCC   L011AC3
         INC
L011AC3  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011ACF
         INC   $F8
L011ACF  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EC
L011AD8  LDA   $EC
         SEC
         SBC   #$0005
         BVS   L011AE3
         EOR   #$8000
L011AE3  BPL   L011A92
         STZ   $EC
         BRA   L011B2F
L011AE9  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011AF3
         INC   $F4
L011AF3  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ADD
         STA   $F6
         LDA   #^L030ADD
         BCC   L011B1A
         INC
L011B1A  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011B26
         INC   $F8
L011B26  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EC
L011B2F  LDA   $EC
         SEC
         SBC   #$0003
         BVS   L011B3A
         EOR   #$8000
L011B3A  BPL   L011AE9
         STZ   $EC
         BRA   L011BA6
L011B40  STZ   $EA
         BRA   L011B97
L011B44  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011B4E
         INC   $F4
L011B4E  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         PHA
         LDA   #$0005
         CLC
         JSL   multiply16BIT
         PLA
         CLC
         ADC   $EA
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AE0
         STA   $F6
         LDA   #^L030AE0
         BCC   L011B82
         INC
L011B82  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011B8E
         INC   $F8
L011B8E  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EA
L011B97  LDA   $EA
         SEC
         SBC   #$0005
         BVS   L011BA2
         EOR   #$8000
L011BA2  BPL   L011B44
         INC   $EC
L011BA6  LDA   $EC
         SEC
         SBC   #$0003
         BVS   L011BB1
         EOR   #$8000
L011BB1  BPL   L011B40
         STZ   $EC
         BRA   L011C16
L011BB7  STZ   $EA
         BRA   L011C07
L011BBB  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011BC5
         INC   $F4
L011BC5  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         ASL
         ASL
         ASL
         CLC
         ADC   $EA
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AEF
         STA   $F6
         LDA   #^L030AEF
         BCC   L011BF2
         INC
L011BF2  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011BFE
         INC   $F8
L011BFE  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EA
L011C07  LDA   $EA
         SEC
         SBC   #$0008
         BVS   L011C12
         EOR   #$8000
L011C12  BPL   L011BBB
         INC   $EC
L011C16  LDA   $EC
         SEC
         SBC   #$0003
         BVS   L011C21
         EOR   #$8000
L011C21  BPL   L011BB7
         STZ   $EC
         BRA   L011C86
L011C27  STZ   $EA
         BRA   L011C77
L011C2B  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011C35
         INC   $F4
L011C35  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         ASL
         ASL
         ASL
         CLC
         ADC   $EA
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030B07
         STA   $F6
         LDA   #^L030B07
         BCC   L011C62
         INC
L011C62  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011C6E
         INC   $F8
L011C6E  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EA
L011C77  LDA   $EA
         SEC
         SBC   #$0008
         BVS   L011C82
         EOR   #$8000
L011C82  BPL   L011C2B
         INC   $EC
L011C86  LDA   $EC
         SEC
         SBC   #$0003
         BVS   L011C91
         EOR   #$8000
L011C91  BPL   L011C27
         STZ   $EC
         BRA   L011CFD
L011C97  STZ   $EA
         BRA   L011CEE
L011C9B  LDX   $F4
         LDA   $F2
         INC   $F2
         BNE   L011CA5
         INC   $F4
L011CA5  STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         PHA
         LDA   #$0005
         CLC
         JSL   multiply16BIT
         PLA
         CLC
         ADC   $EA
         PHA
         LDA   $EE
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030B1F
         STA   $F6
         LDA   #^L030B1F
         adc   #0
	STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L011CE5
         INC   $F8
L011CE5  PLA
         SEP   #$20
         STA   [$F6]
         REP   #$20
         INC   $EA
L011CEE  LDA   $EA
         SEC
         SBC   #$0005
         BVS   L011CF9
         EOR   #$8000
L011CF9  BPL   L011C9B
         INC   $EC
L011CFD  LDA   $EC
         SEC
         SBC   #$0003
         BVS   L011D08
         EOR   #$8000
L011D08  BPL   L011C97
         INC   $EE
L011D0C  LDA   theLEVEL
         AND   #$00FF
         ASL
         TAX
         LDA   L0308E1,X
         SEC
         SBC   $EE
         BEQ   L011D2F
         BVS   L011D22
         EOR   #$8000
L011D22  BPL   L011D2F
         BRL   L011926
L011D2F  TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
* SHOW TITLE PAGE
*-----------------------------------

showTITLE
         PEA   $0001	; dispose handle
         PEA   $0000	; Y1
         PEA   $0000	; X1
         PEA   $0000	; image index
         JSL   showPICTURE	; show picture
         PLY
         PLY
         PLY
         PLY
         JSL   fadeIN

         LDX   haPICTURE+2
         LDA   haPICTURE
         PHX
         PHA
         _DisposeHandle
         LDX   haPICTURE2+2
         LDA   haPICTURE2
         PHX
         PHA
         _DisposeHandle
	
L01261D
	jsl	checkREPLAY

	PHA		; mDownMask
         PEA   $0002	; 0000_0000_0000_0010
         PEA   ^eventREC
         PEA   eventREC
         _GetNextEvent
         PLA
         TAY
         beq   L01261D	; no action

         RTL

*-----------------------------------
* SELECT LANGUAGE
*-----------------------------------

selectLANGUE
	PEA   ^haPICTURE
	PEA   haPICTURE
	PEA   ^strLANGUE	; 1/image1/langue1.gim
	PEA   strLANGUE
	JSL   loadFILE
	PLY
	PLY
	PLY
	PLY

         PEA   $0001	; dispose handle
         PEA   $0000	; Y1 - was 8 for Thomson
         PEA   $0000	; X1 - was 8 for Thomson
         PEA   $0000	; image index
         JSL   showPICTURE	; show picture
         PLY
         PLY
         PLY
         PLY
         JSL   fadeIN

         LDX   haPICTURE+2
         LDA   haPICTURE
         PHX
         PHA
         _DisposeHandle
         LDX   haPICTURE2+2
         LDA   haPICTURE2
         PHX
         PHA
         _DisposeHandle

         LDA   #$0001
         STA   offsetY

	_InitCursor
	
* Wait for an event

langueLOOP
	jsl	checkREPLAY

	PHA		; mDownMask
	PEA   $0002	; 0000_0000_0000_0010
	PEA   ^eventREC
	PEA   eventREC
	_GetNextEvent
	PLA
	beq   langueLOOP	; no action

* Did we click in a rectangle?

	lda	#0
]lp	pha
	asl
	asl
	asl	; *8
	tax
	pea	^locRect
	pea	locRect
	lda	rectLANG+2,x
	pha
	lda	rectLANG,x
	pha
	lda	rectLANG+6,x
	pha
	lda	rectLANG+4,x
	pha
	_SetRect
	
	pha
	PushLong	#oWHERE
	PushLong #locRect
	_PtInRect
	pla
	bne	langueFOUND

	pla		; next language please
	inc
	cmp	#7+1	; 7 langues et 1 easter egg
	bcc	]lp
	bcs	langueLOOP	; not found!

* We have a language
* 0/1	English
* 2	Français
* 3	Dutch
* 4	Espanol
* 5	Italiano (no IT, text files from the web are corrupt)
* 6	Deutsch
* 7	Easter egg
 
langueFOUND
	ldx	#tblFR	; pointer to the translated char table
	pla
	beq	langueOK	; US
	cmp	#1	; UK
	beq	langueOK
	cmp	#2	; FR
	beq	langueNEW
	cmp	#3	; NL
	beq	langueNEW
	cmp	#5	; IT
	beq	langueNEW
	ldx	#tblES
	cmp	#4	; ES
	beq	langueNEW
	ldx	#tblDE
	cmp	#6	; DE
	beq	langueNEW
	cmp	#7	; Play in English by default
	beq	doEGG	; the Easter egg
	bra	langueOK
	
langueNEW
	stx	patchLANGUE+1
	sta	theLANGUE
	sep	#$20
	ora	#'0'
	sta	strTEXT+17
	sta	strTXT+4
	rep	#$20
	
langueOK
	rtl

*--- The Easter egg (50 lines x 52 pixels wide)

doEGG
	lda	oMODIFIERS
	and	#$0900
	cmp	#$0900	; cmd + option
	bne	doEGG9

	lda	#EASTER
	sta	doEGG2+1

	ldx	#0
doEGG1	ldy	#0	; one line
doEGG2	lda	EASTER,y
	stal	$e15e20,x
	inx
	inx
	iny
	iny
	cpy	#26
	bcc	doEGG2
	lda	doEGG2+1	; next line source
	clc
	adc	#26
	sta	doEGG2+1
	txa		; next line destination
	clc
	adc	#160-26
	tax
	cpx	#50*160
	bcc	doEGG1	
doEGG9	brl	langueLOOP
	
*-----------------------------------
* LE COUCHER DE SOLEIL (END OF THE GAME)
*-----------------------------------

doENDGAME
         PEA   ^haPICTURE
         PEA   haPICTURE
         PEA   ^strFINAL	; 1/image1/final1.gim
         PEA   strFINAL
         JSL   loadFILE
         PLY
         PLY
         PLY
         PLY

         PEA   $0001	; dispose handle
         PEA   $0000	; Y1 - was 8 for Thomson
         PEA   $0000	; X1 - was 8 for Thomson
         PEA   $0000	; image index
         JSL   showPICTURE	; show picture
         PLY
         PLY
         PLY
         PLY
         JSL   fadeIN
         LDX   haPICTURE+2
         LDA   haPICTURE
         PHX
         PHA
         _DisposeHandle

         LDA   #$0001	; next pic has a header
         STA   offsetY

* And wait for a keypress again

]lp	jsl	checkREPLAY

	PHA		; mDownMask
         PEA   $0002	; 0000_0000_0000_0010
         PEA   ^eventREC
         PEA   eventREC
         _GetNextEvent
         PLA
         TAY
         beq   ]lp	; no action

* We're done. It is Christmas 2020 and we have the end of the game

         RTL

*-----------------------------------
* HANDLE DIALOG
*-----------------------------------

handleDIALOG
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00E6
         TCS
         STZ   $EC
         LDY   #$001A
         LDA   [$FD],Y
         AND   #$00FF
         STA   $F0

L011DBE	jsl	checkREPLAY

	PHA		; mDownMask + keyDownMask
         PEA   $000A	; 0000_0000_0000_1010
         PEA   ^eventREC
         PEA   eventREC
         _GetNextEvent
         PLA
         TAY
         beq   L011DBE
         LDA   eventREC
         CMP   #$0001	; mouseDownEvt
         BEQ   L011DE4
         BRL   L011EC4

L011DE4  STZ   $F2
         bra   L011E41
L011DE9  PHA
         PEA   ^oWHERE
         PEA   oWHERE
         LDA   $F2
         ASL
         ASL
         ASL
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L011E02
         INC
L011E02  PHA
         PHX
         _PtInRect
         PLA
         TAY
         BEQ   L011E3F
         LDA   $F2
         STA   $F0
         ASL
         ASL
         ASL
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L011E28
         INC
L011E28  PHA
         PHX
         PEA   $000A
         PEA   $0008
         _InvertRRect
         LDA   #$0001
         STA   $EC
L011E3F  INC   $F2
L011E41  LDY   #$001B
         LDA   [$FD],Y
         AND   #$00FF
         SEC
         SBC   $F2
         BEQ   L011E55
         BVS   L011E53
         EOR   #$8000
L011E53  BMI   L011DE9

L011E55	jsl	checkREPLAY

         PHA		; 
         PEA   $0004	; mUpMask
         PEA   ^eventREC
         PEA   eventREC
         _GetNextEvent
         PLA
         TAY
         beq   L011E55
         LDA   $EC
         BEQ   L011EC2
         PHA
         PEA   ^oWHERE
         PEA   oWHERE
         LDA   $F0
         ASL
         ASL
         ASL
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L011E8C
         INC
L011E8C  PHA
         PHX
         _PtInRect
         PLA
         TAY
         BNE   L011EC2
         STZ   $EC
         LDA   $F0
         ASL
         ASL
         ASL
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L011EB0
         INC
L011EB0  PHA
         PHX
         PEA   $000A
         PEA   $0008
         _InvertRRect
L011EC2  BRA   L011EFF

L011EC4  LDA   oMESSAGE	; message is return
         CMP   #$000D
         BNE   L011EFF
         LDA   oMESSAGE+2
         BNE   L011EFF
         LDA   #$0001
         STA   $EC
         LDA   $F0
         ASL
         ASL
         ASL
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L011EED
         INC
L011EED  PHA
         PHX
         PEA   $000A
         PEA   $000A
         _InvertRRect

L011EFF  LDA   $EC
         BNE   L011F06
         BRL   L011DBE
L011F06  jsl   wait15000
         LDX   L020045+2
         LDA   L020045
         STA   $F4
         STX   $F6
         LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         PHX
         PHA
         LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         PHX
         PHA
         JSL   drawIMAGE
         PLY
         PLY
         PLY
         PLY
         LDX   L020045+2
         LDA   L020045
         PHX
         PHA
         _DisposeHandle
         LDA   $F0
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* DRAW DIALOG
*-----------------------------------

* $FD: long - handle

drawDIALOG
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00D8
         TCS
         PEA   $0000
         _SetForeColor
         PEA   $000F
         _SetBackColor
         _PenNormal

         LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         STA   $F4
         STX   $F6

         LDA   [$F4],Y
         STA   $EE
         LDA   [$F4]
         STA   $F0

         LDY   #$0004
         LDA   [$F4],Y
         SEC
         SBC   $F0
         PHA

         LDY   #$0006
         LDA   [$F4],Y
         SEC
         SBC   $EE
         CLC
         ADC   #$000F
         SEC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   #$0002
         SEC
         JSL   L015794
         PLY
         LDX   #$0000
         TAY
         BPL   L01202F
         DEX
L01202F  STX   $EC
         STA   $EA
         PHX
         PHA
         PEI   $EC
         PEI   $EA
         LDA   myID
         PHA
         PEA   $8010
         PEA   $0000
         PEA   $0000
         _NewHandle
         PLA
         PLX
         STX   L020045+2
         STA   L020045

         LDA   $EE
         CLC
         ADC   #$000B
         STA   $EE

         LDA   $F0
         CLC
         ADC   #$0012
         STA   $F0

         LDX   L020045+2
         LDA   L020045
         STA   $F4
         STX   $F6

         LDY   #$0002
         LDA   [$F4],Y
         pha
         LDA   [$F4]
         pha
         LDA   [$FD],Y
         pha
         LDA   [$FD]
         pha
         JSL   copyBACKGROUND
         PLY
         PLY
         PLY
         PLY

         LDY   #$0002
         LDA   [$FD],Y
         pha
         LDA   [$FD]
         pha
         PEA   $000A
         PEA   $0008
         _EraseRRect
         LDY   #$0002
         LDA   [$FD],Y
         pha
         LDA   [$FD]
	pha
         PEA   $000A
         PEA   $0008
         _FrameRRect
         LDY   #$0002
         LDA   [$FD],Y
         pha
         LDA   [$FD]
         pha
         PEA   $0003
         PEA   $0003
         _InsetRect
         PEA   $0002
         PEA   $0002
         _SetPenSize
         LDY   #$0002
         LDA   [$FD],Y
         pha
         LDA   [$FD]
         PHA
         PEA   $000A
         PEA   $0008
         _FrameRRect
         PEA   $0001
         PEA   $0001
         _SetPenSize

         LDY   #$0018	; is there an image available?
         LDA   [$FD],Y
         CMP   #$FFFF
         BEQ   L012196	; no

         PEA   $0000	; push 1 - do not dispose memory
         LDA   $F0
         SEC
         SBC   #$0008
         PHA		; push 2 - Y1
         PEI   $EE	; push 3 - X1

	pea   $0001	; push 4 - image index
         JSL   showPICTURE
         PLY
         PLY
         PLY
         PLY

         LDA   $EE
         CLC
         ADC   #$003C
         STA   $EE
         LDA   $F0
         CLC
         ADC   #$0003
         STA   $F0
         PEA   $0000
         TDC
         CLC
         ADC   #$00DA
         PHA
         PEI   $EE
         PEI   $F0
         PEI   $EE
         PEI   $F0
         _SetRect

L012196  LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         PHX
         PHA
         PEA   $FFFD
         PEA   $FFFD
         _InsetRect
         STZ   $F2
         BRL   L01229A
L0121B5  PEI   $EE
         LDA   $F2
         PHA
         LDA   #$000B
         SEC
         JSL   multiply16BIT
         PLA
	sta   $f4
         LDA   $F0
         CLC
         ADC   $F4
         PHA
         _MoveTo
         LDA   $F2
         ASL
         ASL
         PHA
         LDA   $FD
         CLC
         ADC   #$0004
         STA   $F4
         LDA   $FF
         BCC   L0121E9
         INC
L0121E9  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L0121F5
         INC   $F6
L0121F5  LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         STX   $F4
         ORA   $F4
         BNE   L012206
         BRL   L012298
L012206  LDA   $F2
         ASL
         ASL
         PHA
         LDA   $FD
         CLC
         ADC   #$0004
         STA   $F4
         LDA   $FF
         BCC   L012218
         INC
L012218  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012224
         INC   $F6
L012224  LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         PHX
         PHA
         PEA   $0000
         TDC
         CLC
         ADC   #$00E2
         PHA
         _CStringBounds
         PEA   $0000
         TDC
         CLC
         ADC   #$00E2
         PHA
         PEA   $0000
         TDC
         CLC
         ADC   #$00DA
         PHA
         PEA   $0000
         TDC
         CLC
         ADC   #$00DA
         PHA
         _UnionRect
         LDA   $F2
         ASL
         ASL
         PHA
         LDA   $FD
         CLC
         ADC   #$0004
         STA   $F4
         LDA   $FF
         BCC   L012278
         INC
L012278  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012284
         INC   $F6
L012284  LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         PHX
         PHA
         _DrawCString
L012298  INC   $F2
L01229A  LDA   $F2
         SEC
         SBC   #$0005
         BVS   L0122A5
         EOR   #$8000
L0122A5  BMI   L0122AA
         BRL   L0121B5
L0122AA  LDY   #$0018
         LDA   [$FD],Y
         CMP   #$FFFF
         BEQ   L0122E6
         PEA   $0000
         TDC
         CLC
         ADC   #$00DA
         PHA
         PEA   $FFFA
         PEA   $FFFA
         _InsetRect
         PEA   $0000
         TDC
         CLC
         ADC   #$00DA
         PHA
         PEA   $0014
         PEA   $0010
         _FrameRRect
L0122E6  STZ   $F2
         BRL   L012488
L0122EB  LDA   $F2
         ASL
         ASL
         PHA
         LDA   $FD
         CLC
         ADC   #$001C
         STA   $F4
         LDA   $FF
         BCC   L0122FD
         INC
L0122FD  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012309
         INC   $F6
L012309  LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         STA   $F4
         STX   $F6
         LDY   #$0002
         LDA   [$F4],Y
         PHA
         LDA   $F2
         ASL
         ASL
         PHA
         LDA   $FD
         CLC
         ADC   #$001C
         STA   $F4
         LDA   $FF
         BCC   L01232D
         INC
L01232D  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012339
         INC   $F6
L012339  LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         STA   $F4
         STX   $F6
         LDA   [$F4]
         PHA
         _MoveTo
         LDA   $F2
         ASL
         ASL
         PHA
         LDA   $FD
         CLC
         ADC   #$0028
         STA   $F4
         LDA   $FF
         BCC   L012364
         INC
L012364  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012370
         INC   $F6
L012370  LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         PHX
         PHA
         LDA   $F2
         ASL
         ASL
         ASL
         TAX
         TXA
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L01238C
         INC
L01238C  PHA
         PHX
         _CStringBounds
         LDA   $F2
         ASL
         ASL
         PHA
         LDA   $FD
         CLC
         ADC   #$0028
         STA   $F4
         LDA   $FF
         BCC   L0123AA
         INC
L0123AA  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L0123B6
         INC   $F6
L0123B6  LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         PHX
         PHA
         _DrawCString
         LDA   $F2
         ASL
         ASL
         ASL
         TAX
         TXA
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L0123DC
         INC
L0123DC  PHA
         PHX
         PEA   $FFFD
         PEA   $FFFD
         _InsetRect
         LDA   $F2
         ASL
         ASL
         ASL
         TAX
         TXA
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L012400
         INC
L012400  PHA
         PHX
         PEA   $000A
         PEA   $0008
         _FrameRRect
         LDY   #$001A
         LDA   [$FD],Y
         AND   #$00FF
         CMP   $F2
         BNE   L012486
         LDA   $F2
         ASL
         ASL
         ASL
         TAX
         TXA
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L012430
         INC
L012430  PHA
         PHX
         PEA   $FFFD
         PEA   $FFFD
         _InsetRect
         PEA   $0002
         PEA   $0002
         _SetPenSize
         LDA   $F2
         ASL
         ASL
         ASL
         TAX
         TXA
         CLC
         ADC   #L030350
         TAX
         LDA   #^L030350
         BCC   L012464
         INC
L012464  PHA
         PHX
         PEA   $000A
         PEA   $0008
         _FrameRRect
         PEA   $0001
         PEA   $0001
         _SetPenSize
L012486  INC   $F2
L012488  LDY   #$001B
         LDA   [$FD],Y
         AND   #$00FF
         SEC
         SBC   $F2
         BEQ   L01249F
         BVS   L01249A
         EOR   #$8000
L01249A  BPL   L01249F
         BRL   L0122EB
L01249F  PEA   $000F
         _SetForeColor
         PEA   $0000
         _SetBackColor
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* SHOW A DIALOG
*-----------------------------------

showDIALOG
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         PEI   $FF
         PEI   $FD
         JSL   drawDIALOG
         PLY
         PLY
         PEI   $FF
         PEI   $FD
         JSL   handleDIALOG
         PLY
         PLY
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* GET MOUSE X
*-----------------------------------
* Gets the X position of the mouse
* to help regulate the speed of the replay

getMOUSEX
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00DA
         TCS
         PHA
         PEA   $0002	; event
         PEA   $0000
         TDC
         CLC
         ADC   #$00E0
         PHA
         _GetNextEvent
         PLA
         TAY
         BEQ   L01254E
L012533  PHA
         PEA   $0004	; event
         PEA   $0000
         TDC
         CLC
         ADC   #$00E0
         PHA
         _GetNextEvent
         PLA
         TAY
         BEQ   L012533

L01254E  PEA   $0000
         TDC
         CLC
         ADC   #$00DC
         PHA
         _GetMouse
         LDA   #$0140	; 320 - X position
         SEC
         SBC   $DE
         TAY
         TDC
         CLC
         ADC   #$00FB
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* INIT THE GAME
*-----------------------------------

initGAME
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F5
         TCS

         LDA   #$0000
         STA   fgREPLAY
         STA   L020092
         STA   L020094
         STA   replayINDEX
         STA   replaySTEP
         SEP   #$20
         STA   fgCGCOND
         STA   curCHAR
         STA   theLEVEL
         REP   #$20

         PEA   ^haTXT	; load IMAGE1/Text.TXTy
         PEA   haTXT	; at haTXT
         PEA   ^strTEXT
         PEA   strTEXT
         JSL   loadFILE
         PLY
         PLY
         PLY
         PLY
         LDX   haTXT+2	; deference handle
         LDA   haTXT
         STA   $F8
         STX   $FA
         LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STX   ptrTEXT+2
         STA   ptrTEXT

         JSL   doSOUNDON

         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* WAIT 15000
*-----------------------------------

wait15000
	lda	#15000
]lp	dec
	bpl	]lp
	rtl

*-----------------------------------
* REGULATE MOUSE SPEED
*-----------------------------------
* You can regulate the speed of the replay

regulateSPEED
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F2
         TCS
         STZ   $F4
         BRA   L012695
L012674  JSL   getMOUSEX	; wait mouse down/mouse up
         STA   $F6	; return 320 - X position
         PHA
         LDA   #$0006
         SEC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   #$0001
         PLX
         STX   $F8
         CLC
         ADC   $F8
         STA   L020032
         INC   $F4
L012695  LDA   $F4
         SEC
         SBC   L020032
         BVS   L0126A0
         EOR   #$8000
L0126A0  BPL   L012674
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* SHOW CHARACTER ICON
*-----------------------------------
* showCHARACTER(index, x1, y1)
* $FB: word - image index
* $FD: word - 08 X1
* $FF: word - 90 Y1

showCHARACTER
         PHD
         TSC
         SEC
         SBC   #$00F5
         TCD
         ADC   #$00E5
         TCS
         LDA   $FB
         AND   #$00FF
         BNE   L0126BF
         BRL   L0127F3
L0126BF  LDA   $FD
         CMP   #$0008
         BNE   L0126CD
         LDA   $FF
         CMP   #$0090
         BEQ   L0126EB
L0126CD  JSL   showIMAGE

*         LDA   L02002F
*         AND   #$00FF
*         BEQ   L0126EB

         LDA   $FB
         AND   #$00FF
         STA   L02008A
         LDA   $FD
         STA   L02008E
         LDA   $FF
         STA   L020090

L0126EB  LDA   $FB
         AND   #$00FF
         SEC
         SBC   #$0032
         BVS   L0126F9
         EOR   #$8000
L0126F9  BMI   L012713

         PEA   $0000	; do not dispose memory
         PEI   $FF	; Y1
         PEI   $FD	; X1
         LDA   $FB
         AND   #$00FF
         PHA		; image index
         JSL   showPICTURE
         PLY
         PLY
         PLY
         PLY
         BRL   L0127F3

* Multiple images to display

L012713  LDA   $FB
         AND   #$00FF
         SEC
         SBC   #$0032
         STA   $E9
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         LDA   L03099D,X
         AND   #$00FF
         STA   $E7	; number of strips to show

         STZ   $EB
         BRL   L0127E4
L012739  LDA   $EB
         PHA
         LDA   $E9
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L03099E
         STA   $F2
         LDA   #^L03099E
         BCC   L012756
         INC
L012756  STA   $F4
         PLA
         CLC
         ADC   $F2
         STA   $F2
         BCC   L012762
         INC   $F4
L012762  LDA   [$F2]
         AND   #$00FF
         SEP   #$20
         STA   $F1
         REP   #$20
         LDA   $EB
         ASL
         PHA
         LDA   $E9
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L0309A3
         STA   $F2
         LDA   #^L0309A3
         BCC   L01278B
         INC
L01278B  STA   $F4
         PLA
         CLC
         ADC   $F2
         STA   $F2
         BCC   L012797
         INC   $F4
L012797  LDA   [$F2]
         STA   $EF
         LDA   $EB
         ASL
         PHA
         LDA   $E9
         PHA
         LDA   #$001A
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L0309AD
         STA   $F2
         LDA   #^L0309AD
         BCC   L0127B9
         INC
L0127B9  STA   $F4
         PLA
         CLC
         ADC   $F2
         STA   $F2
         BCC   L0127C5
         INC   $F4
L0127C5  LDA   [$F2]
         STA   $ED
         PEA   $0000	; do not dispose memory
         PEI   $ED	; Y1
         PEI   $EF	; X1
         LDA   $F1
         AND   #$00FF
         PHA		; image index
         JSL   showPICTURE
         PLY
         PLY
         PLY
         PLY
         jsl   wait15000
         INC   $EB
L0127E4  LDA   $EB
         SEC
         SBC   $E7
         BVS   L0127EE
         EOR   #$8000
L0127EE  BMI   L0127F3
         BRL   L012739

L0127F3  TDC
         CLC
         ADC   #$00F5
         TCS
         PLD
         RTL

*-----------------------------------
* CHECK WHERE USER CLICKED
*-----------------------------------
*
* $E8: flag (0: no point found, 1: point found)
* $EA: index(0..C)

checkPTINRECT
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00DE
         TCS
         STZ   $E8
         STZ   $EA
         BRL   L01288F

L01280D  PEA   $0000
         TDC
         CLC
         ADC   #$00E0
         PHA
         LDA   $EA
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         LDA   theRECTANGLES,X
         PHA		; long
         LDA   $EA
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         LDA   theRECTANGLES+2,X
         PHA		; long
         LDA   $EA
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         LDA   theRECTANGLES+4,X
         PHA		; long
         LDA   $EA
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         LDA   theRECTANGLES+4+2,X
         PHA		; long
         _SetRect
         PHA
         PEI   $FF
         PEI   $FD
         PEA   $0000
         TDC
         CLC
         ADC   #$00E0
         PHA
         _PtInRect
         PLA
         TAY
         BEQ   L01288D
         LDA   #$0001	; point in a rect
         STA   $E8
         INC   $EA	; return index
         BRA   L01289F	; exit

L01288D  INC   $EA	; next index
L01288F  LDA   $EA	; until 12
         SEC
         SBC   #$000C
         BVS   L01289A
         EOR   #$8000
L01289A  BMI   L01289F
         BRL   L01280D

L01289F  LDA   $E8	; did we click in a rectangle?
         BEQ   L0128A7	; no
         LDA   $EA	; yes, return index
         BRA   L0128AA
L0128A7  LDA   #$0000
L0128AA  TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* SELECT PREVIOUS CHARACTER
*-----------------------------------
* we clicked in the lower left frame, up rectangle
* $FF: current selected character

setPREVIOUSCHAR
         PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F3
         TCS
         LDA   $FF	; which char was active?
         AND   #$00FF
         SEP   #$20
         STA   $F5	; used at the end
         REP   #$20
         DEC   $FF	; get previous character
L0128CC  LDA   $FF
         AND   #$00FF
         BEQ   L0128E8	; is zero?
         DEC   $FF	; no, decrement again
         LDA   $FF	; because x4
         ASL
         ASL
         TAX
         LDA   L032FD9,X	; check active?
         AND   #$00FF
         beq   L0128CC

L0128E8  LDA   $FF	; get our char
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD9,X	; does it have an icon?
         AND   #$00FF
         BEQ   L012951

         PEA   $0090	; change icon sprite
         PEA   $0008
         LDA   $FF	; char+1
         AND   #$00FF
         CLC
         ADC   #$0001
         PHA
         JSL   showCHARACTER
         PLY
         PLY
         PLY
         LDA   $FF
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD9,X
         AND   #$00FF
         STA   L020094
         LDA   $FF
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD7,X
         AND   #$00FF
         PHA
         LDA   L020094
         PLX
         STX   $F6
         CLC
         ADC   $F6
         SEC
         SBC   #$0001
         STA   L020092
         LDA   $FF
         AND   #$00FF
         CLC
         ADC   #$0001
         SEP   #$20
         STA   $F5
         REP   #$20
L012951  LDA   $F5	; exit
         AND   #$00FF
         TAY
         TDC
         CLC
         ADC   #$00F9
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* SET NEXT CHAR
*-----------------------------------
* We clicked the down rectangle of the lower left corner
* $FF: current character

setNEXTCHAR
         PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F3
         TCS
         LDA   $FF
         AND   #$00FF
         SEP   #$20
         STA   $F5
         REP   #$20
         DEC   $FF
L012978  LDA   $FF
         AND   #$00FF
         SEC
         SBC   #$0013
         BVS   L012986
         EOR   #$8000
L012986  BMI   L01299D
         INC   $FF
         LDA   $FF
         ASL
         ASL
         TAX
         LDA   L032FD9,X
         AND   #$00FF
         beq   L012978
L01299D  LDA   $FF
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD9,X
         AND   #$00FF
         BEQ   L012A06
         PEA   $0090
         PEA   $0008
         LDA   $FF
         AND   #$00FF
         CLC
         ADC   #$0001
         PHA
         JSL   showCHARACTER	; show icon
         PLY
         PLY
         PLY
         LDA   $FF
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD9,X
         AND   #$00FF
         STA   L020094
         LDA   $FF
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD7,X
         AND   #$00FF
         PHA
         LDA   L020094
         PLX
         STX   $F6
         CLC
         ADC   $F6
         SEC
         SBC   #$0001
         STA   L020092
         LDA   $FF
         AND   #$00FF
         CLC
         ADC   #$0001
         SEP   #$20
         STA   $F5
         REP   #$20
L012A06  LDA   $F5
         AND   #$00FF
         TAY
         TDC
         CLC
         ADC   #$00F9
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* SET PREVIOUS MESSAGE
*-----------------------------------
* We clicked the upper rectangle of the right window frame
* That way we want to select the first possible answer (there are only two)
*
* $FD: message index

setPREVIOUSMESSAGE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         BNE   L012A27
         BRL   L012AA6
L012A27  DEC   $FD
         LDA   $FD
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ADD
         STA   $F4
         LDA   #^L030ADD
         BCC   L012A47
         INC
L012A47  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012A53
         INC   $F6
L012A53  LDA   [$F4]
         AND   #$00FF
         BNE   L012A5E
         INC   $FD
         BRA   L012AA6
L012A5E  PEA   $0001
         LDA   $FF
         AND   #$00FF
         PHA
         JSL   printTEXT	; the first text
         PLY
         PLY
         PEA   $0000
         LDA   $FD
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ADD
         STA   $F4
         LDA   #^L030ADD
         BCC   L012A8E
         INC
L012A8E  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012A9A
         INC   $F6
L012A9A  LDA   [$F4]
         AND   #$00FF
         PHA
         JSL   printTEXT	; the second text
         PLY
         PLY
L012AA6  LDA   $FD
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* SET NEXT MESSAGE
*-----------------------------------
* We clicked the lower rectangle of the right frame
* We want the second message
*
* $FD: message index

setNEXTMESSAGE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         SEC
         SBC   #$0002
         BVS   L012AC8
         EOR   #$8000
L012AC8  BPL   L012ACD
         BRL   L012B4C
L012ACD  INC   $FD
         LDA   $FD
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         CLC
         ADC   #L030ADD
         STA   $F4
         LDA   #^L030ADD
         BCC   L012AED
         INC
L012AED  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012AF9
         INC   $F6
L012AF9  LDA   [$F4]
         AND   #$00FF
         BNE   L012B04
         DEC   $FD
         BRA   L012B4C
L012B04  PEA   $0001
         LDA   $FF
         AND   #$00FF
         PHA
         JSL   printTEXT	; the first text
         PLY
         PLY
         PEA   $0000
         LDA   $FD
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         CLC
         ADC   #L030ADD
         STA   $F4
         LDA   #^L030ADD
         BCC   L012B34
         INC
L012B34  STA   $F6
         PLA
         CLC
         ADC   $F4
         STA   $F4
         BCC   L012B40
         INC   $F6
L012B40  LDA   [$F4]
         AND   #$00FF
         PHA
         JSL   printTEXT	; the second text
         PLY
         PLY
L012B4C  LDA   $FD
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* LOGO
*-----------------------------------

L012B58  PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F2
         TCS
         STZ   $F6
         LDA   #$0001
         SEP   #$20
         STA   $F4
         REP   #$20

L012B6E  LDA   $F6
         SEC
         SBC   #$0005
         BVS   L012B79
         EOR   #$8000
L012B79  BMI   L012BD3

         LDA   $F4
         AND   #$00FF
         BEQ   L012BD3

         LDA   $F6
         INC   $F6
         PHA

         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AC7
         STA   $F8
         LDA   #^L030AC7
         BCC   L012BA2
         INC
L012BA2  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L012BAE
         INC   $FA
L012BAE  LDA   [$F8]
         AND   #$00FF
         SEP   #$20
         STA   $F5
         REP   #$20
         AND   #$00FF
         BEQ   L012BD1
         LDA   $F5
         AND   #$00FF
         TAX
         LDA   tblCONDITIONS,X
         AND   #$00FF
         SEP   #$20
         STA   $F4
         REP   #$20
L012BD1  BRA   L012B6E

L012BD3  LDA   $F4
         AND   #$00FF
         BEQ   L012BDF
         LDA   #$0000
         BRA   L012BE2

L012BDF  LDA   #$0001
L012BE2  TAY
         TDC
         CLC
         ADC   #$00FB
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* CREATE BACKUP TABLE
*-----------------------------------

createBACKUPLEVEL
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F4
         TCS

         STZ   $F6
         BRA   L012C14
L012BFB  LDA   $F6
         TAX
         LDA   tblCONDITIONS,X
         AND   #$00FF
         PHA
         LDA   $F6
         TAX
         PLA
         SEP   #$20
         STA   tblCONDITIONS2,X
         REP   #$20
         INC   $F6
L012C14  LDA   $F6
         SEC
         SBC   #$0100
         BVS   L012C1F
         EOR   #$8000
L012C1F  BPL   L012BFB

         SEP   #$20
         LDA   fgTALKING
         STA   fgTALKING2
         LDA   theLEVEL
         STA   theLEVEL2
         LDA   curCHAR
         STA   curCHAR2
         REP   #$20
         LDA   L02008A
         STA   L0200A2
         LDA   L02008C
         STA   L0200A4
         LDA   L02008E
         STA   L0200A6
         LDA   L020090
         STA   L0200A8

         STZ   $F6
         BRA   L012CAE
L012C5B  LDA   $F6
         ASL
         ASL
         TAX
         LDA   L032FD7,X
         AND   #$00FF
         PHA
         LDA   $F6
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L033027,X
         REP   #$20
         LDA   $F6
         ASL
         ASL
         TAX
         LDA   L032FD8,X
         AND   #$00FF
         PHA
         LDA   $F6
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L033028,X
         REP   #$20
         LDA   $F6
         ASL
         ASL
         TAX
         LDA   L032FD9,X
         AND   #$00FF
         PHA
         LDA   $F6
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L033029,X
         REP   #$20
         INC   $F6
L012CAE  LDA   $F6
         SEC
         SBC   #$0014
         BVS   L012CB9
         EOR   #$8000
L012CB9  BPL   L012C5B
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* RESTORE BACKUP TABLE
*-----------------------------------

restoreBACKUPLEVEL
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F4
         TCS
         STZ   $F6
         BRA   L012CEB
L012CD2  LDA   $F6
         TAX
         LDA   tblCONDITIONS2,X
         AND   #$00FF
         PHA
         LDA   $F6
         TAX
         PLA
         SEP   #$20
         STA   tblCONDITIONS,X
         REP   #$20
         INC   $F6
L012CEB  LDA   $F6
         SEC
         SBC   #$0100
         BVS   L012CF6
         EOR   #$8000
L012CF6  BPL   L012CD2

         SEP   #$20
         LDA   fgTALKING2
         STA   fgTALKING
         LDA   theLEVEL2
         STA   theLEVEL
         LDA   curCHAR2
         STA   curCHAR
         REP   #$20
         LDA   L0200A2
         STA   L02008A
         LDA   L0200A4
         STA   L02008C
         LDA   L0200A6
         STA   L02008E
         LDA   L0200A8
         STA   L020090

         STZ   $F6
L012D32  LDA   $F6
         ASL
         ASL
         TAX
         LDA   L033027,X
         AND   #$00FF
         SEP   #$20
         STA   L032FD7,X
         REP   #$20

         LDA   L033028,X
         AND   #$00FF
         SEP   #$20
         STA   L032FD8,X
         REP   #$20

         LDA   L033029,X
         AND   #$00FF
         SEP   #$20
         STA   L032FD9,X
         REP   #$20

         INC   $F6

L012D85  LDA   $F6
         SEC
         SBC   #$0014
         BVS   L012D90
         EOR   #$8000
L012D90  BPL   L012D32
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* LOGO
*-----------------------------------

L012D9A  PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F2
         TCS
         STZ   $F4
         BRA   L012DED
L012DA9  LDA   $F4
         INC   $F4
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AD8
         STA   $F8
         LDA   #^L030AD8
         BCC   L012DC9
         INC
L012DC9  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L012DD5
         INC   $FA
L012DD5  LDA   [$F8]
         AND   #$00FF
         STA   $F6
         TAY
         BEQ   L012DED
         LDA   $F6
         TAX
         LDA   #$0001
         SEP   #$20
         STA   tblCONDITIONS,X
         REP   #$20
L012DED  LDA   $F4
         SEC
         SBC   #$0005
         BVS   L012DF8
         EOR   #$8000
L012DF8  BPL   L012DA9
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* LOGO
*-----------------------------------

L012E02  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00EA
         TCS
         LDA   #$0001
         STA   $F2
         STZ   $EE
L012E14  LDA   $EE
         SEC
         SBC   #$0005
         BVS   L012E1F
         EOR   #$8000
L012E1F  BMI   L012E7C
         LDA   $F2
         BEQ   L012E7C
         LDA   $FF
         PHA
         LDA   #$0005
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   $EE
         INC   $EE
         PLX
         STX   $F6
         CLC
         ADC   $F6
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AE0
         STA   $F6
         LDA   #^L030AE0
         BCC   L012E58
         INC
L012E58  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L012E64
         INC   $F8
L012E64  LDA   [$F6]
         AND   #$00FF
         STA   $F4
         TAY
         BEQ   L012E7A
         LDA   $F4
         TAX
         LDA   tblCONDITIONS,X
         AND   #$00FF
         STA   $F2
L012E7A  BRA   L012E14
L012E7C  STZ   $EE
         LDA   $F2
         BNE   L012E85
         BRL   L012F2B
L012E85  BRL   L012F18
L012E88  LDA   $FF
         ASL
         ASL
         ASL
         CLC
         ADC   $EE
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AEF
         STA   $F6
         LDA   #^L030AEF
         BCC   L012EAC
         INC
L012EAC  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L012EB8
         INC   $F8
L012EB8  LDA   [$F6]
         AND   #$00FF
         STA   $EC
         TAY
         BEQ   L012F10
         LDA   $FF
         ASL
         ASL
         ASL
         PHA
         LDA   $EE
         CLC
         ADC   #$0001
         PLX
         STX   $F6
         CLC
         ADC   $F6
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AEF
         STA   $F6
         LDA   #^L030AEF
         BCC   L012EF0
         INC
L012EF0  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L012EFC
         INC   $F8
L012EFC  LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L032FD5,X
         REP   #$20
L012F10  LDA   $EE
         CLC
         ADC   #$0002
         STA   $EE
L012F18  LDA   $EE
         SEC
         SBC   #$0008
         BVS   L012F23
         EOR   #$8000
L012F23  BMI   L012F28
         BRL   L012E88
L012F28  BRL   L012FCE
L012F2B  BRL   L012FBE

L012F2E  LDA   $FF
         ASL
         ASL
         ASL
         CLC
         ADC   $EE
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         CLC
         ADC   #L030B07
         STA   $F6
         LDA   #^L030B07
         BCC   L012F52
         INC
L012F52  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L012F5E
         INC   $F8
L012F5E  LDA   [$F6]
         AND   #$00FF
         STA   $EC
         TAY
         BEQ   L012FB6
         LDA   $FF
         ASL
         ASL
         ASL
         PHA
         LDA   $EE
         CLC
         ADC   #$0001
         PLX
         STX   $F6
         CLC
         ADC   $F6
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         CLC
         ADC   #L030B07
         STA   $F6
         LDA   #^L030B07
	adc   #0
         STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L012FA2
         INC   $F8
L012FA2  LDA   [$F6]
         AND   #$00FF
         PHA
         LDA   $EC
         ASL
         ASL
         TAX
         PLA
         SEP   #$20
         STA   L032FD5,X
         REP   #$20
L012FB6  LDA   $EE
         CLC
         ADC   #$0002
         STA   $EE
L012FBE  LDA   $EE
         SEC
         SBC   #$0008
         BVS   L012FC9
         EOR   #$8000
L012FC9  BMI   L012FCE
         BRL   L012F2E
L012FCE  STZ   $EE
         BRA   L013029
L012FD2  LDA   $FF
         PHA
         LDA   #$0005
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   $EE
         INC   $EE
         PLX
         STX   $F6
         CLC
         ADC   $F6
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         CLC
         ADC   #L030B1F
         STA   $F6
         LDA   #^L030B1F
         adc   #0
         STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L013011
         INC   $F8
L013011  LDA   [$F6]
         AND   #$00FF
         STA   $F0
         TAY
         BEQ   L013029
         LDA   $F0
         TAX
         LDA   #$0001
         SEP   #$20
         STA   tblCONDITIONS,X
         REP   #$20
L013029  LDA   $EE
         SEC
         SBC   #$0005
         BVS   L013034
         EOR   #$8000
L013034  BPL   L012FD2
         LDA   curCHAR
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD5,X
         AND   #$00FF
         STA   L020094
         LDA   curCHAR
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD3,X
         AND   #$00FF
         PHA
         LDA   L020094
         SEC
         SBC   #$0001
         PLX
         STX   $F6
         CLC
         ADC   $F6
         STA   L020092
         TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
* HANDLE TALKING
*-----------------------------------
* Check if we clicked in the dialog area

handleTALKING
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00EC
         TCS
         STZ   $F2
         SEP   #$20
         STZ   $F5
         REP   #$20
         PEA   $0101
         _DisableMItem
         PEA   $0102
         _DisableMItem
         PEA   $0103
         _DisableMItem
         PEA   $0104
         _DisableMItem

         JSL   L012B58
         AND   #$00FF
         SEP   #$20
         STA   $F4
         REP   #$20
         LDA   $F4
         AND   #$00FF
         ASL
         ASL
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AD0
         STA   $F8
         LDA   #^L030AD0
         BCC   L0130E9
         INC
L0130E9  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L0130F5
         INC   $FA
L0130F5  LDY   #$0002
         LDA   [$F8],Y
         PHA
         LDA   $F4
         AND   #$00FF
         ASL
         ASL
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030AD0
         STA   $F8
         LDA   #^L030AD0
         BCC   L01311E
         INC
L01311E  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L01312A
         INC   $FA
L01312A  LDA   [$F8]
         PHA
         LDA   $F4
         AND   #$00FF
         ASL
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ACC
         STA   $F8
         LDA   #^L030ACC
         BCC   L01314F
         INC
L01314F  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L01315B
         INC   $FA
L01315B  LDY   #$0001
         LDA   [$F8],Y
         AND   #$00FF
         PHA
         JSL   showCHARACTER
         PLY
         PLY
         PLY
         LDA   $F4
         AND   #$00FF
         ASL
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ACC
         STA   $F8
         LDA   #^L030ACC
         BCC   L01318D
         INC
L01318D  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013199
         INC   $FA
L013199  LDA   [$F8]
         AND   #$00FF
         SEP   #$20
         STA   $F7
         REP   #$20
         LDA   $F7
         AND   #$00FF
         STA   L02008C
         PEA   $0001
         LDA   $F7
         AND   #$00FF
         PHA
         JSL   printTEXT
         PLY
         PLY
         LDA   $F4
         AND   #$00FF
         BEQ   L0131C8
         BRL   L0132CD
L0131C8  JSL   L012D9A
         LDA   $F2
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ADD
         STA   $F8
         LDA   #^L030ADD
         BCC   L0131EA
         INC
L0131EA  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L0131F6
         INC   $FA
L0131F6  LDA   [$F8]
         AND   #$00FF
         BNE   L013200
         BRL   L0132C6
L013200  PEA   $0000
         LDA   $F2
         PHA
         LDA   L020092
         PHA
         LDA   #$0068
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #L030ADD
         STA   $F8
         LDA   #^L030ADD
         BCC   L013221
         INC
L013221  STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L01322D
         INC   $FA
L01322D  LDA   [$F8]
         AND   #$00FF
         PHA
         JSL   printTEXT
         PLY
         PLY

L013239  pea   $0000
         JSL   checkEVENT
         PLY
         PEA   ^oWHERE
         PEA   oWHERE
         JSL   checkPTINRECT	; where on the board did we click?
         PLY
         PLY
         SEP   #$20
         STA   $F6
         REP   #$20
         AND   #$00FF

*--- 1: lower right frame, high rectangle (up)

         CMP   #$0001
         bne   L013276

         LDA   $F7
         AND   #$00FF
         PHA
         PEI   $F2
         JSL   setPREVIOUSMESSAGE
         PLY
         PLY
         STA   $F2
         bra   L0132BC
*         BRA   L01327D

*--- 2: lower right frame, low rectangle (down)

L013276  CMP   #$0002
         bne   L013291

         LDA   $F7
         AND   #$00FF
         PHA
         PEI   $F2
         JSL   setNEXTMESSAGE
         PLY
         PLY
         STA   $F2
         BRA   L0132BC
*         BRA   L013298

*--- 6: lower right frame (answer selection)

L013291  CMP   #$0006
         bne   L0132A7

         jsl   paintRIGHTRECT
         LDA   #$0001
         SEP   #$20
         STA   $F5
         REP   #$20
         BRA   L0132BC

*--- Check replay mode

L0132A7  LDA   fgREPLAY
         BNE   L0132BC
         LDA   replaySTEP
         SEC
         SBC   #$0002
         STA   replaySTEP

*---

L0132BC  LDA   $F5	; are we done yet?
         AND   #$00FF
         beq   L013239	; no
	
L0132C6  PEI   $F2	; yes
         JSL   L012E02
         PLY

L0132CD  PEA   $0101
         _EnableMItem
         PEA   $0102
         _EnableMItem
         PEA   $0103
         _EnableMItem
         PEA   $0104
         _EnableMItem

         LDA   $F5
         AND   #$00FF
         TAY
         TDC
         CLC
         ADC   #$00FB
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* LOGO
*-----------------------------------

L013310  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F1
         TCS
         STZ   $F3
         BRL   L0133DA
L013320  LDA   $F3
         PHA
         LDA   $FF
         AND   #$00FF
         PHA
         LDA   #$000E
         CLC
         JSL   multiply16BIT
         PLA
         TAX
         TXA
         CLC
         ADC   #theRECTANGLES2
         STA   $F6
         LDA   #^theRECTANGLES2
         BCC   L013340
         INC
L013340  STA   $F8
         PLA
         CLC
         ADC   $F6
         STA   $F6
         BCC   L01334C
         INC   $F8
L01334C  LDA   [$F6]
         AND   #$00FF
         SEP   #$20
         STA   $F5
         REP   #$20
         AND   #$00FF
         BNE   L01335F
         BRL   L0133D8
L01335F  LDA   $F5
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD4,X
         AND   #$00FF
         bne   L0133D8
L013376  LDA   $F5
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   #$0001
         SEP   #$20
         STA   L032FD4,X
         REP   #$20
         LDA   $F5
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   #$0001
         SEP   #$20
         STA   L032FD5,X
         REP   #$20
         LDA   #$0001
         STA   L020094
         LDA   $F3
         BNE   L0133D8
         LDA   $F5
         SEP   #$20
         STA   curCHAR
         REP   #$20
         LDA   $F5
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD3,X
         AND   #$00FF
         STA   L020092
         PEA   $0090
         PEA   $0008
         LDA   curCHAR
         AND   #$00FF
         PHA
         JSL   showCHARACTER
         PLY
         PLY
         PLY
L0133D8  INC   $F3
L0133DA  LDA   $F3
         SEC
         SBC   #$0005
         BVS   L0133E5
         EOR   #$8000
L0133E5  BMI   L0133EA
         BRL   L013320
L0133EA  TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
* CLEAR GAME CONDITIONS
*-----------------------------------

clearGAMECONDITIONS
         ldx	#256-2
]lp	stz	tblCONDITIONS,x
	dex
	dex
	bpl	]lp
	rtl
	
*-----------------------------------
* CLEAR GAME CONDITIONS 2
*-----------------------------------

clearGAMECONDITIONS2
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F4
         TCS
         STZ   $F6
         BRA   L013445
L013435  LDA   $F6
         INC   $F6
         TAX
         LDA   #$0000
         SEP   #$20
         STA   tblCONDITIONS,X
         REP   #$20
L013445  LDA   $F6
         SEC
         SBC   #$0014
         BVS   L013450
         EOR   #$8000
L013450  BPL   L013435
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* CHECK LEVEL END
*-----------------------------------
* Did we win a level?

checkLEVELEND
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F3
         TCS
         LDA   #$0000
         SEP   #$20
         STA   $F5
         REP   #$20
         AND   #$00FF
         SEP   #$20
         STA   $F6
         REP   #$20
         SEP   #$20
         STZ   $F7
         REP   #$20
L01347D  LDA   $F6
         AND   #$00FF
         SEC
         SBC   #$0014
         BVS   L01348B
         EOR   #$8000
L01348B  BMI   L0134AE
         LDA   $F6
         AND   #$00FF
         INC   $F6
         ASL
         ASL
         TAX
         LDA   L032FD9,X
         AND   #$00FF
         SEP   #$20
         STA   $F5
         REP   #$20
         AND   #$00FF
         CMP   #$0063
         bne   L01347D
L0134AE  LDA   $F5
         AND   #$00FF
         CMP   #$0063
         BEQ   L0134BB
         BRL   L01355F

L0134BB  INC   theLEVEL	; next level please
         STZ   L02008A
         STZ   L02008C
         STZ   L02008E
         STZ   L020090
         LDX   L02004D+2
         LDA   L02004D
         PHX
         PHA
         _DisposeHandle
         LDX   haBTM+2
         LDA   haBTM
         PHX
         PHA
         _DisposeHandle
         LDX   haTXT+2
         LDA   haTXT
         PHX
         PHA
         _DisposeHandle
         LDX   haHANDLE+2
         LDA   haHANDLE
         PHX
         PHA
         _DisposeHandle

         LDA   theLEVEL	; check level
         AND   #$00FF
         CMP   #$0005
         BNE   L013520
         INC   theLEVEL	; coz, there's no level 5

L013520  LDA   theLEVEL	; did we reach level 9?
         AND   #$00FF
         CMP   #10	; was 9
         BNE   L013538
         JSL   doENDGAME	; yes, we won
	
	sep	#$20
	stz	theLEVEL
	rep	#$20
	
*L01352F  LDA   #$0001	; infinite loop
*         BEQ   L013536	; pas cool les programmeurs !
*         BRA   L01352F
*L013536  BRA   L01355F

L013538  SEP   #$20	; next level, play now
         STZ   fgCGCOND
         REP   #$20
         STZ   replaySTEP
         LDA   theLEVEL
         AND   #$00FF
         PHA
         JSL   prepareLEVEL
         PLY
         JSL   clearGAMECONDITIONS2
         JSL   createBACKUPLEVEL
         LDA   #$0001
         SEP   #$20
         STA   $F7
         REP   #$20

L01355F  LDA   $F7
         AND   #$00FF
         TAY
         TDC
         CLC
         ADC   #$00FB
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* MAIN
*-----------------------------------

main
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F0
         TCS
         LDA   #$0001
         STA   curEPISODE
         PEA   ^strONE	; 1
         PEA   strONE
         PEA   ^strTWO	; Add 2 to the string
         PEA   strTWO
         JSL   copyCSTRING
         PLY
         PLY
         PLY
         PLY
         JSL	initDESKTOP
	jsl	doSOUNDON
         JSL	showTITLE
	jsl	selectLANGUE
         JSL	initGAME
         JSL	clearGAMECONDITIONS
	
         LDA   #$0000
         STA   L020090
         STA   L02008E
         STA   L02008C
         STA   L02008A
         LDA   theLEVEL
         AND   #$00FF
         PHA
         JSL   prepareLEVEL
         PLY
	JSL   makeMENUBAR
         JSL   createBACKUPLEVEL

L013637  LDA   fgCGCOND
         AND   #$00FF
         BNE   L013643
         JSL   clearGAMECONDITIONS

L013643  LDA   #$0000
         SEP   #$20
         STA   fgTALKING	; active characters?
         STA   fgCGCOND
         STA   $F7
         REP   #$20

L013660  LDA   $F7
         AND   #$00FF
	bne   L013637

L01366A  pea   $0001
         JSL   checkEVENT
         PLY
         SEP   #$20
         STA   fgCGCOND
         REP   #$20
         AND   #$00FF
         bne   L013637

L013685  PEA   ^oWHERE	; where did we click?
         PEA   oWHERE
         JSL   checkPTINRECT
         PLY
         PLY
         SEP   #$20
         STA   $F6
         REP   #$20
         AND   #$00FF
         CMP   #$0007	; in a frame
         BEQ   L0136BA
         CMP   #$0008	; of the
         BEQ   L0136BA
         CMP   #$0009	; main picture
         BEQ   L0136BA
         CMP   #$000A	; of the game
         BEQ   L0136BA
         CMP   #$000B	; window
         BEQ   L0136BA
         CMP   #$000C	; perhaps?
         bne   L0136D8

L0136BA  SEC		; yes, we did
         SBC   #$0001
         PHA
         JSL   L013310	; handle the click
         PLY
         LDA   #$0001
         SEP   #$20
         STA   fgTALKING	; activate talking
         REP   #$20
         bra   L013768
*         BRA   L0136DF

*--- 3: lower left frame, high box (up)

L0136D8  CMP   #$0003
         bne   L013702

         LDA   fgTALKING	; do we have characters?
         AND   #$00FF
         BEQ   L0136FD
         LDA   curCHAR	; which was the char?
         AND   #$00FF
         PHA
         JSL   setPREVIOUSCHAR
         PLY
         AND   #$00FF
         SEP   #$20
         STA   curCHAR	; save new char
         REP   #$20
L0136FD  bra   L013768
*        BRA   L013709

*--- 4: lower left frame, low box (down)

L013702  CMP   #$0004
         bne   L01372C

         LDA   fgTALKING	; do we have characters?
         AND   #$00FF
         BEQ   L013727

         LDA   curCHAR	; which was the active char?
         AND   #$00FF
         PHA
         JSL   setNEXTCHAR
         PLY
         AND   #$00FF
         SEP   #$20
         STA   curCHAR
         REP   #$20
L013727  bra   L013768
*         BRA   L013734

*--- 5: lower left frame (make them talk)

L01372C  CMP   #$0005
         bne   L013753

         LDA   fgTALKING	; do we have characters?
         AND   #$00FF
         BEQ   L013768
         LDA   L020094	; are they talking already?
         BEQ   L013768

L013741  JSL   handleTALKING
         AND   #$00FF
         BEQ   L013768
         LDA   L020094
         bne   L013741
         BRA   L013768

L013753  LDA   fgREPLAY	; check replay
         BNE   L013768
         LDA   replaySTEP	; replay--
         SEC		; replay--
         SBC   #$0002
         STA   replaySTEP

L013768  JSL   checkLEVELEND	; did we win the level?
         AND   #$00FF
         SEP   #$20
         STA   $F7
         REP   #$20
         BRL   L013660

*-----------------------------------
* FADE IN
*-----------------------------------

fadeIN
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00EA
         TCS
         SEP   #$20
         STZ   $F7
         REP   #$20
         BRL   L013BED
L0137EF  SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L0138A3
L0137F8  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013830
         INC   $FA
L013830  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L013842
         DEC   $FA
L013842  CLC
         ADC   $F8
         STA   $F8
         BCC   L01384B
         INC   $FA
L01384B  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013865
         INX
L013865  STX   $EE
         STA   $EC
         LDA   [$EC]
         AND   #$000F
         PHA
         LDA   [$F0]
         AND   #$000F
         PLX
         STX   $F8
         CMP   $F8
         BEQ   L013880
         LDA   #$0001
         BRA   L013883
L013880  LDA   #$0000
L013883  PHA
         LDA   [$EC]
         AND   #$000F
         PLX
         STX   $F8
         CLC
         ADC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$FFF0
         STA   $F8
         PLA
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L0138A3  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L0138B0
         BRL   L0137F8
L0138B0  STZ   $F4
         BRA   L0138B6
L0138B4  INC   $F4
L0138B6  LDA   $F4
         CMP   #$02BC
         BNE   L0138B4
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L01399E
L0138E3  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L01391B
         INC   $FA
L01391B  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L01392D
         DEC   $FA
L01392D  CLC
         ADC   $F8
         STA   $F8
         BCC   L013936
         INC   $FA
L013936  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013950
         INX
L013950  STX   $EE
         STA   $EC
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PHA
         LDA   [$F0]
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         CMP   $F8
         BEQ   L013973
         LDA   #$0001
         BRA   L013976
L013973  LDA   #$0000
L013976  PHA
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         CLC
         ADC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$FF0F
         STA   $F8
         PLA
         ASL
         ASL
         ASL
         ASL
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L01399E  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L0139AB
         BRL   L0138E3
L0139AB  STZ   $F4
         BRA   L0139B1
L0139AF  INC   $F4
L0139B1  LDA   $F4
         CMP   #$0320
         BNE   L0139AF
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L013AA9
L0139DE  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013A16
         INC   $FA
L013A16  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L013A28
         DEC   $FA
L013A28  CLC
         ADC   $F8
         STA   $F8
         BCC   L013A31
         INC   $FA
L013A31  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013A4B
         INX
L013A4B  STX   $EE
         STA   $EC
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PHA
         LDA   [$F0]
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         CMP   $F8
         BEQ   L013A76
         LDA   #$0001
         BRA   L013A79
L013A76  LDA   #$0000
L013A79  PHA
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         CLC
         ADC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$F0FF
         STA   $F8
         PLA
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L013AA9  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L013AB6
         BRL   L0139DE
L013AB6  STZ   $F4
         BRA   L013ABC
L013ABA  INC   $F4
L013ABC  LDA   $F4
         CMP   #$0320
         BNE   L013ABA
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L013BB4
L013AE9  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013B21
         INC   $FA
L013B21  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L013B33
         DEC   $FA
L013B33  CLC
         ADC   $F8
         STA   $F8
         BCC   L013B3C
         INC   $FA
L013B3C  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013B56
         INX
L013B56  STX   $EE
         STA   $EC
         LDA   [$EC]
         XBA
         AND   #$00FF
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PHA
         LDA   [$F0]
         XBA
         AND   #$00FF
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         CMP   $F8
         BEQ   L013B81
         LDA   #$0001
         BRA   L013B84
L013B81  LDA   #$0000
L013B84  PHA
         LDA   [$EC]
         XBA
         AND   #$00FF
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         CLC
         ADC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$0FFF
         STA   $F8
         PLA
         XBA
         AND   #$FF00
         ASL
         ASL
         ASL
         ASL
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L013BB4  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L013BC1
         BRL   L013AE9
L013BC1  STZ   $F4
         BRA   L013BC7
L013BC5  INC   $F4
L013BC7  LDA   $F4
         CMP   #$0320
         BNE   L013BC5
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         INC   $F7
L013BED  LDA   $F7
         AND   #$00FF
         CMP   #$000F
         BEQ   L013BFA
         BRL   L0137EF
L013BFA  _InitPalette
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* FADE TO PALETTE
*-----------------------------------

fadeTOPALETTE
	PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00EA
         TCS
         SEP   #$20
         STZ   $F7
         REP   #$20
         BRL   L013FE2
L013C20  SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L013CCA
L013C29  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013C61
         INC   $FA
L013C61  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L013C73
         DEC   $FA
L013C73  CLC
         ADC   $F8
         STA   $F8
         BCC   L013C7C
         INC   $FA
L013C7C  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013C96
         INX
L013C96  STX   $EE
         STA   $EC
         LDA   [$EC]
         AND   #$000F
         TAY
         BEQ   L013CA7
         LDA   #$0001
         BRA   L013CAA
L013CA7  LDA   #$0000
L013CAA  PHA
         LDA   [$EC]
         AND   #$000F
         PLX
         STX   $F8
         SEC
         SBC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$FFF0
         STA   $F8
         PLA
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L013CCA  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L013CD7
         BRL   L013C29
L013CD7  STZ   $F4
         BRA   L013CDD
L013CDB  INC   $F4
L013CDD  LDA   $F4
         CMP   #$0258	; 600
         BNE   L013CDB
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L013DB7
L013D0A  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013D42
         INC   $FA
L013D42  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L013D54
         DEC   $FA
L013D54  CLC
         ADC   $F8
         STA   $F8
         BCC   L013D5D
         INC   $FA
L013D5D  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013D77
         INX
L013D77  STX   $EE
         STA   $EC
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         TAY
         BEQ   L013D8C
         LDA   #$0001
         BRA   L013D8F
L013D8C  LDA   #$0000
L013D8F  PHA
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         SEC
         SBC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$FF0F
         STA   $F8
         PLA
         ASL
         ASL
         ASL
         ASL
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L013DB7  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L013DC4
         BRL   L013D0A
L013DC4  STZ   $F4
         BRA   L013DCA
L013DC8  INC   $F4
L013DCA  LDA   $F4
         CMP   #$0258	; 600
         BNE   L013DC8
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L013EB0
L013DF7  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013E2F
         INC   $FA
L013E2F  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L013E41
         DEC   $FA
L013E41  CLC
         ADC   $F8
         STA   $F8
         BCC   L013E4A
         INC   $FA
L013E4A  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013E64
         INX
L013E64  STX   $EE
         STA   $EC
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         TAY
         BEQ   L013E7D
         LDA   #$0001
         BRA   L013E80
L013E7D  LDA   #$0000
L013E80  PHA
         LDA   [$EC]
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         SEC
         SBC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$F0FF
         STA   $F8
         PLA
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ASL
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L013EB0  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L013EBD
         BRL   L013DF7
L013EBD  STZ   $F4
         BRA   L013EC3
L013EC1  INC   $F4
L013EC3  LDA   $F4
         CMP   #$0258	; 600
         BNE   L013EC1
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         SEP   #$20
         STZ   $F6
         REP   #$20
         BRL   L013FA9
L013EF0  LDA   $F6
         AND   #$00FF
         ASL
         PHA
         LDA   curEPISODE
         PHA
         LDA   #$0000
         CLC
         JSL   multiply16BIT
         PLA
         PHA
         LDA   theLEVEL
         AND   #$00FF
         PLX
         STX   $F8
         CLC
         ADC   $F8
         ASL
         ASL
         PHA
         LDA   #tblPALETTE
         STA   $F8
         LDA   #^tblPALETTE
         STA   $FA
         PLA
         CLC
         ADC   $F8
         STA   $F8
         BCC   L013F28
         INC   $FA
L013F28  LDY   #$0002
         LDA   [$F8],Y
         TAX
         LDA   [$F8]
         STA   $F8
         STX   $FA
         PLA
         TAY
         BPL   L013F3A
         DEC   $FA
L013F3A  CLC
         ADC   $F8
         STA   $F8
         BCC   L013F43
         INC   $FA
L013F43  LDA   $F8
         LDX   $FA
         STX   $F2
         STA   $F0
         LDA   $F6
         AND   #$00FF
         ASL
         TAX
         TXA
         CLC
         ADC   #thePALETTE
         LDX   #^thePALETTE
         BCC   L013F5D
         INX
L013F5D  STX   $EE
         STA   $EC
         LDA   [$EC]
         XBA
         AND   #$00FF
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         TAY
         BEQ   L013F76
         LDA   #$0001
         BRA   L013F79
L013F76  LDA   #$0000
L013F79  PHA
         LDA   [$EC]
         XBA
         AND   #$00FF
         LSR
         LSR
         LSR
         LSR
         AND   #$000F
         PLX
         STX   $F8
         SEC
         SBC   $F8
         AND   #$000F
         PHA
         PHA
         LDA   [$EC]
         AND   #$0FFF
         STA   $F8
         PLA
         XBA
         AND   #$FF00
         ASL
         ASL
         ASL
         ASL
         ORA   $F8
         STA   [$EC]
         PLA
         INC   $F6
L013FA9  LDA   $F6
         AND   #$00FF
         CMP   #$0010
         BEQ   L013FB6
         BRL   L013EF0
L013FB6  STZ   $F4
         BRA   L013FBC
L013FBA  INC   $F4
L013FBC  LDA   $F4
         CMP   #$0258	; 600
         BNE   L013FBA
         PEA   $0000
         PEA   ^thePALETTE
         PEA   thePALETTE
         _SetColorTable
         _InitPalette
         INC   $F7
L013FE2  LDA   $F7
         AND   #$00FF
         CMP   #$000F
         BEQ   L013FEF
         BRL   L013C20
L013FEF  TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* BACK TO THE LAUNCHER
*-----------------------------------

exitPROGRAM

	jsl	stopMIDI
	jsl	TWILIGHTon
	
	PushWord #0
	PushLong ssREC
	_ShutDownTools

	PushWord myID
         _MMShutDown
         _TLShutDown

         JSL   GSOS
         DW    $0029      ; Quit
         ADRL  L030368

         brk   $bd

*-----------------------------------
* SHOW THE MENU BAR
*-----------------------------------

makeMENUBAR
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS

         PEA   $0000
         _DeleteMenu
         PHX
         PHA
         PEA   ^L030446
         PEA   L030446
         _NewMenu
         PLA
         PLX
         PHX
         PHA
         PEA   $0000
         _InsertMenu
         PHX
         PHA
         PEA   ^L03041B
         PEA   L03041B
         _NewMenu
         PLA
         PLX
         PHX
         PHA
         PEA   $0000
         _InsertMenu
         PHX
         PHA
         PEA   ^L0303AE
         PEA   L0303AE
         _NewMenu
         PLA
         PLX
         PHX
         PHA
         PEA   $0000
         _InsertMenu
         PHA
         _FixMenuBar
         PLA
         STZ   fgMENUBAR
         JSL   showIMAGE

         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* INIT TOOLS & GAME
*-----------------------------------

startTOOLS
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00E6
         TCS

         _TLStartUp
         PHA
         _MMStartUp
	PullWord myID

	PushLong	#0	; we want 64K for our backup screen (32K needed)
	PushLong	#$10000
	PushWord	myID
	PushWord	#%11000000_00011100
	PushLong	#0
	_NewHandle
	phd
	tsc
	tcd
	lda	[3]
	sta	saveBACK1+1
	sta	loadBACK1+1
	ldy	#1
	lda	[3],y
	sta	saveBACK1+2
	sta	loadBACK1+2
	pld
	pla
	pla

	pha
	pha
	PushWord	myID
	PushWord	#0	; ref is by pointer
	PushLong #toolTBL2
	_StartUpTools
	PullLong ssREC

*---
	
	_HideCursor	; we do not want to see the cursor yet
	
         LDA   #$0007
         STA   offsetY

         LDA   #10	; First level is level 10 !
         SEP   #$20
         STA   theLEVEL
         REP   #$20
         PEA   ^haPICTURE
         PEA   haPICTURE
         PEA   ^strGARBIN	; 1/image1/garlpdv1.bin
         PEA   strGARBIN
         JSL   loadFILE
         PLY
         PLY
         PLY
         PLY

*--- Muzak please

	phd
	jsl	initMIDI
	pld
	
*---
	
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* SAVE THE SHR SCREEN
*-----------------------------------

saveBACK
	_HideCursor

	ldx	#$8000-2
]lp	ldal	$e12000,x
saveBACK1 stal	$bdbdbd,x
	dex
	dex
	bpl	]lp
	
exitBACK	_ShowCursor
	rtl

*-----------------------------------
* RESTORE THE SHR SCREEN
*-----------------------------------

loadBACK
	_HideCursor

	ldx	#$8000-2
loadBACK1 ldal	$bdbdbd,x
	stal	$e12000,x
	dex
	dex
	bpl	loadBACK1
	bmi	exitBACK

*-----------------------------------
* GET MEMORY FOR BACKGROUNDS
*-----------------------------------

getMENUBACKRAM
	PHD
	TSC
	SEC
	SBC   #$00FB
	TCD
	ADC   #$00F6
	TCS

         PHX
         PHA
         PEA   $0960
         LDA   myID
         PHA
         PEA   $8010
         PEA   $0000
         PEA   $0000
         _NewHandle
         PLA
         PLX
         STX   haMENUBAR+2
         STA   haMENUBAR

         PHX
         PHA
         PEA   $0000
         PEA   $0C80
         LDA   myID
         PHA
         PEA   $8010
         PEA   $0000
         PEA   $0000
         _NewHandle
         PLA
         PLX
         STX   haBACKGROUND+2
         STA   haBACKGROUND

         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL
         RTL

*-----------------------------------
* INIT DESKTOP
*-----------------------------------

initDESKTOP
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS

	jsl	TWILIGHToff
	
         JSL	startTOOLS

         PHX
         PHA
         _GetPort
         PLA
         PLX
         STX   theGRAFPORT+2
         STA   theGRAFPORT
         JSL   getMENUBACKRAM

         PEA   $0000
         _SetBackColor
         PEA   $000F
         _SetForeColor

         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* BUILD A PATH
*-----------------------------------

buildPATH
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         PEA   ^strIMAGE	; 1/IMAGE
         PEA   strIMAGE
         PEA   ^L030921	; empty string
         PEA   L030921
         JSL   copyCSTRING
         PLY
         PLY
         PLY
         PLY
         PEA   ^strTWO	; 2
         PEA   strTWO
         PEA   ^L030921	; to the above string
         PEA   L030921
         JSL   appendCSTRING
         PLY
         PLY
         PLY
         PLY
         PEA   ^strSLASH	; /
         PEA   strSLASH
         PEA   ^L030921	; to the above string
         PEA   L030921
         JSL   appendCSTRING
         PLY
         PLY
         PLY
         PLY
         PEI   $FF
         PEI   $FD
         PEA   ^L030921	; to the above string
         PEA   L030921
         JSL   appendCSTRING
         PLY
         PLY
         PLY
         PLY
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* LOAD LEVEL
*-----------------------------------

loadLEVEL
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00DA
         TCS
         STZ   $E8	; 0

         LDA   theLEVEL
         AND   #$00FF
         BEQ   L0143F1

         PEA   ^L030759	; It's loading dialog
         PEA   L030759
         JSL   drawDIALOG
         PLY
         PLY
         LDX   L020045+2
         LDA   L020045
         PHX
         PHA
         _DisposeHandle

L0143F1  PEI   $FF
         PEI   $FD
         JSL   buildPATH
         PLY
         PLY
         PEA   ^strBTM	; .BTM
         PEA   strBTM
         PEA   ^L030921
         PEA   L030921
         JSL   appendCSTRING
         PLY
         PLY
         PLY
         PLY
         PEA   ^haBTM
         PEA   haBTM
         PEA   ^L030921
         PEA   L030921
         JSL   loadFILE
         PLY
         PLY
         PLY
         PLY
         PEI   $FF
         PEI   $FD
         JSL   buildPATH
         PLY
         PLY
         PEA   ^strTXT	; .TXT
         PEA   strTXT
         PEA   ^L030921
         PEA   L030921
         JSL   appendCSTRING
         PLY
         PLY
         PLY
         PLY
         PEA   ^haTXT
         PEA   haTXT
         PEA   ^L030921
         PEA   L030921
         JSL   loadFILE
         PLY
         PLY
         PLY
         PLY
         LDX   #$0000
         LDA   #$0005
         PHX
         PHA
         LDX   haTXT+2
         LDA   haTXT
         STA   $F4
         STX   $F6
         LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         JSL   add32BIT
         PLA
         PLX
         STX   ptrTXT+2
         STA   ptrTXT
         PHX
         PHA
         PEA   $0000
         PEA   $2EE0
         LDA   myID
         PHA
         PEA   $8000
         PEA   $0000
         PEA   $0000
         _NewHandle
         PLA
         PLX
         STX   $DE
         STA   $DC
         PEI   $FF
         PEI   $FD
         JSL   buildPATH
         PLY
         PLY
         PEA   ^strSTR	; .STR
         PEA   strSTR
         PEA   ^L030921
         PEA   L030921
         JSL   appendCSTRING
         PLY
         PLY
         PLY
         PLY
         LDY   #$0002	; dereference handle
         LDA   [$DC],Y
         TAX
         LDA   [$DC]
         STX   ptrSTR+2	; points to ptrSTR
         STA   ptrSTR

* Decode the STR file

         PEA   ^haSTR	; loads the .STR file
         PEA   haSTR
         PEA   ^L030921
         PEA   L030921
         JSL   loadFILE
         PLY
         PLY
         PLY
         PLY
         STA   $EA

         LDX   haSTR+2	; dereference handle
         LDA   haSTR
         STA   $F4
         STX   $F6
         LDY   #$0002
         LDA   [$F4],Y
         TAX
         LDA   [$F4]
         STX   $E6
         STA   $E4
         STZ   $F0
         BRL   L0145D6

* $E4: points to ptrSTR
* $F0: zero on entry
* $F4: copy of ptrSTR

L014506  LDA   $F0	; for(i=0, i++, i=EOF)
         PHA
         LDX   $E6
         LDA   $E4
         STA   $F4
         STX   $F6
         PLA
         TAY
         BPL   L014517
         DEC   $F6
L014517  CLC
         ADC   $F4
         STA   $F4
         BCC   L014520
         INC   $F6
L014520  LDA   [$F4]	; if(*ptrSTR[i] == 0)
         AND   #$00FF
         BNE   L01458F
         STZ   $EE	; {	k = 0
         BRA   L014557
L01452E  LDA   $E8	; 
         INC   $E8
         PHA
         LDX   ptrSTR+2
         LDA   ptrSTR
         STA   $F4
         STX   $F6
         PLA
         TAY
         BPL   L014543
         DEC   $F6
L014543  CLC
         ADC   $F4
         STA   $F4
         BCC   L01454C
         INC   $F6
L01454C  LDA   #$0000	; *ptrSTR[j] = 0
         SEP   #$20	; j++
         STA   [$F4]
         REP   #$20
         INC   $EE	; k++

L014557  LDA   $F0
         PHA
         LDX   $E6
         LDA   $E4
         STA   $F4
         STX   $F6
         PLA
         TAY
         BPL   L014568
         DEC   $F6
L014568  CLC
         ADC   $F4
         STA   $F4
         BCC   L014571
         INC   $F6
L014571  LDY   #$0001	; 
         LDA   [$F4],Y
         AND   #$00FF
         SEC
         SBC   $EE
         BEQ   L014585
         BVS   L014583
         EOR   #$8000
L014583  BMI   L01452E
L014585  LDA   $F0
         CLC
         ADC   #$0002
         STA   $F0
         BRA   L0145D6

L01458F  LDA   $F0	; } else {
         INC   $F0
         PHA
         LDX   $E6
         LDA   $E4
         STA   $F4
         STX   $F6
         PLA
         TAY
         BPL   L0145A2
         DEC   $F6
L0145A2  CLC
         ADC   $F4
         STA   $F4
         BCC   L0145AB
         INC   $F6
L0145AB  LDA   [$F4]	; *ptr[$E8] = *ptr[i]
         AND   #$00FF
         PHA
         LDA   $E8
         INC   $E8
         PHA
         LDX   ptrSTR+2
         LDA   ptrSTR
         STA   $F4
         STX   $F6
         PLA
         TAY
         BPL   L0145C6
         DEC   $F6
L0145C6  CLC
         ADC   $F4
         STA   $F4
         BCC   L0145CF
         INC   $F6
L0145CF  PLA
         SEP   #$20
         STA   [$F4]
         REP   #$20

L0145D6  LDA   $F0	; entry point
         SEC		; $F0 - $EA
         SBC   $EA
         BVS   L0145E0
         EOR   #$8000
L0145E0  BMI   L0145E5
         BRL   L014506

*---

L0145E5  LDX   #$0000
         LDA   #$0003
         PHX
         PHA
         LDX   ptrSTR+2
         LDA   ptrSTR
         JSL   add32BIT
         PLA
         PLX
         STX   ptrSTR2+2
         STA   ptrSTR2
         LDA   fgCGCOND
         AND   #$00FF
         BNE   L01460F
         PEA   $0000
         JSL   L0114E5
         PLY
L01460F  pea   $0000
         pea   $003C
         LDX   ptrSTR2+2
         LDA   ptrSTR2
         JSL   add32BIT
         PLA
         PLX
         STX   ptrSTR2+2
         STA   ptrSTR2
         PEA   $0001
         JSL   L0114E5
         PLY
         pea   $001A
*         LDA   theLEVEL
*         AND   #$00FF
*         ASL
*         TAX
*         LDA   L0308F5,X
	lda   #5
         SEC
         JSL   multiply16BIT
         PLA
         LDX   #$0000
         PHX
         PHA
         LDX   ptrSTR2+2
         LDA   ptrSTR2
         JSL   add32BIT
         PLA
         PLX
         STX   ptrSTR2+2
         STA   ptrSTR2
         PEA   $0002
         JSL   L0114E5
         PLY
         pea   $0000
         pea   $009C
         LDX   ptrSTR2+2
         LDA   ptrSTR2
         JSL   add32BIT
         PLA
         PLX
         STX   ptrSTR2+2
         STA   ptrSTR2
         PEA   $0003
         JSL   L0114E5
         PLY
         LDX   haSTR+2
         LDA   haSTR
         PHX
         PHA
         _DisposeHandle
         PEI   $FF
         PEI   $FD
         JSL   buildPATH
         PLY
         PLY
         PEA   ^strGIM	; .GIM
         PEA   strGIM
         PEA   ^L030921
         PEA   L030921
         JSL   appendCSTRING
         PLY
         PLY
         PLY
         PLY
         PEA   ^haGIM
         PEA   haGIM
         PEA   ^L030921
         PEA   L030921
         JSL   loadFILE
         PLY
         PLY
         PLY
         PLY
         LDX   haGIM+2
         LDA   haGIM
         STX   haPICTURE+2
         STA   haPICTURE

         LDA   theLEVEL
         AND   #$00FF
         SEC
         SBC   #$0009
         BEQ   L01470A
         BVS   L0146EE
         EOR   #$8000
L0146EE  BPL   L01470A

L0146F0  jsl	checkREPLAY

	PHA
         PEA   $0002	; mDownMask
         PEA   ^eventREC
         PEA   eventREC
         _GetNextEvent
         PLA
         TAY
         beq   L0146F0

L01470A  PEA   $0001	; disposeHandle
         PEA   $0000	; Y1
         PEA   $0000	; X1
         PEA   $0001	; image index
         JSL   showPICTURE
         PLY
         PLY
         PLY
         PLY
	
         LDX   haPICTURE2+2
         LDA   haPICTURE2
         STX   haHANDLE+2
         STA   haHANDLE

         jsl   paintRIGHTRECT

         PEA   $0001
         LDA   theLEVEL
         AND   #$00FF
         CLC
         ADC   #$00C8
         PHA
         JSL   printTEXT
         PLY
         PLY
         JSL   fadeIN
         JSL   saveICON

         LDX   haGIM+2
         LDA   haGIM
         PHX
         PHA
         _DisposeHandle

         LDX   haBTM+2
         LDA   haBTM
         STX   haPICTURE+2
         STA   haPICTURE

         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* PREPARE LEVEL
*-----------------------------------
* prepareLEVEL(int level)

prepareLEVEL
         PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00DC
         TCS
         PEA   ^strPRESE	; PRESE
         PEA   strPRESE
         PEA   $0000
         TDC
         CLC
         ADC   #$00E2
         PHA
         JSL   copyCSTRING
         PLY
         PLY
         PLY
         PLY

	sep	#$20
	lda	$ff
	clc
	adc	#'0'
	sta	$e7
	stz	$e8
	rep	#$20

         PEA   $0000
         TDC
         CLC
         ADC   #$00E2
         PHA
         JSL   loadLEVEL
         PLY
         PLY
         TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
* SAVE PARTY
*-----------------------------------

doSAVE
         PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F0
         TCS

	jsl	doSOUNDOFF
	jsl	saveBACK	; save the background
	
	PushWord	#25
	PushWord #36
	PushLong #strSAVEFILE
	PushLong #namePATH
	PushWord #15
	PushLong #replyPTR
	_SFPutFile

	jsl	loadBACK	; restore the background
	jsl	doSOUNDON

	lda	replyPTR
	beq	noSAVEPARTY

         JSL   saveSAUVE

noSAVEPARTY	
         TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
* LOAD PARTY
*-----------------------------------

doLOAD
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F0
         TCS
         LDA   $FD
         AND   #$00FF
         CMP   #$0001
         BEQ   L01481B
noLOADPARTY
         BRL   L014921

L01481B
	jsl	doSOUNDOFF
	jsl	saveBACK	; save the background
	
	PushWord	#30
	PushWord #43
	PushLong #strLOADFILE
	PushLong #0
	PushLong #typeLIST
	PushLong #replyPTR
	_SFGetFile

	jsl	loadBACK	; restore the background
	jsl	doSOUNDON
	
	lda	replyPTR
	beq	noLOADPARTY

         LDA   theLEVEL
         SEP   #$20
         STA   $FF
         REP   #$20
	
         JSL   loadSAUVE
         jsl   paintRIGHTRECT
	
	sep   #$20
         LDA   $FF	; is load party
	cmp   theLEVEL	; on the same level?
         beq   L0104B0	; yes, jump to next phase

         LDA   #$01
         STA   fgCGCOND

         REP   #$20
         LDX   L02004D+2
         LDA   L02004D
         PHX
         PHA
         _DisposeHandle
         LDX   haBTM+2
         LDA   haBTM
         PHX
         PHA
         _DisposeHandle
         LDX   haTXT+2
         LDA   haTXT
         PHX
         PHA
         _DisposeHandle
         LDX   haHANDLE+2
         LDA   haHANDLE
         PHX
         PHA
         _DisposeHandle
         LDA   theLEVEL
         AND   #$00FF
         PHA
         JSL   prepareLEVEL
         PLY
         BRA   L0148B4

L0104B0	rep   #$20
         JSL   showIMAGE	; same level

L0148B4  LDA   curCHAR
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD5,X
         AND   #$00FF
         STA   L020094
         LDA   L032FD3,X
         AND   #$00FF
         sta   $f4
         LDA   L020094
         SEC
         SBC   #$0001
         CLC
         ADC   $F4
         STA   L020092
         LDA   L020094
         BEQ   L014901
         PEA   $0090
         PEA   $0008
         LDA   curCHAR
         AND   #$00FF
         PHA
         JSL   showCHARACTER
         PLY
         PLY
         PLY
L014901  PEA   $0001
         LDA   L02008C
         PHA
         JSL   printTEXT
         PLY
         PLY
         LDA   L020090
         PHA
         LDA   L02008E
         PHA
         LDA   L02008A
         PHA
         JSL   showCHARACTER
         PLY
         PLY
         PLY

L014921  TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* QUIT
*-----------------------------------

doQUIT
*	PHD
*	TSC
*	SEC
*	SBC   #$00FB
*	TCD
*	ADC   #$00F6
*	TCS
         PEA   ^L030725
         PEA   L030725
         JSL   showDIALOG
         PLY
         PLY
         TAY
         BNE   L014947
         JSL   exitPROGRAM
L014947
*	TDC
*         CLC
*         ADC   #$00FB
*         TCS
*         PLD
         RTL

*-----------------------------------
* ABOUT
*-----------------------------------

doABOUT
*	PHD
*	TSC
*	SEC
*	SBC   #$00FB
*	TCD
*	ADC   #$00F6
*	TCS
         PEA   ^L0306F1
         PEA   L0306F1
         JSL   showDIALOG
         PLY
         PLY
*         TDC
*         CLC
*         ADC   #$00FB
*         TCS
*         PLD
         RTL
         
*-----------------------------------
* ACTIVATE THE REPLAY MODE
*-----------------------------------

doREPLAY
*         PHD
*         TSC
*         SEC
*         SBC   #$00FB
*         TCD
*         ADC   #$00F6
*         TCS
         JSL   restoreBACKUPLEVEL
         LDA   #$0001
         STA   fgREPLAY
         STZ   replayINDEX
         JSL   showIMAGE
         JSL   showICON
         jsl   paintRIGHTRECT

         PEA   ^L03027C
         PEA   L03027C
         _SetCursor

*         TDC
*         CLC
*         ADC   #$00FB
*         TCS
*         PLD
         RTL

*-----------------------------------
* DRAW GAME BOARD 
*-----------------------------------
* We redraw all the elements of the game board

drawGAMEBOARD
         PHD
         TSC
         SEC
         SBC   #$00FB
         TCD
         ADC   #$00F6
         TCS
         JSL   restoreBACKUPLEVEL
         STZ   replaySTEP
         JSL   showIMAGE
         JSL   showICON
         jsl   paintRIGHTRECT
         LDA   curCHAR
         AND   #$00FF
         ASL
         ASL
         TAX
         LDA   L032FD5,X
         AND   #$00FF
         STA   L020094
         LDA   L032FD3,X
         AND   #$00FF
         sta   $f8
         LDA   L020094
         SEC
         SBC   #$0001
         CLC
         ADC   $F8
         STA   L020092
         LDA   L020094
         BEQ   L014A09
         PEA   $0090	; draw character icon
         PEA   $0008
         LDA   curCHAR
         AND   #$00FF
         PHA
         JSL   showCHARACTER
         PLY
         PLY
         PLY
L014A09  LDA   L020090	; Y
         PHA
         LDA   L02008E	; X
         PHA
         LDA   L02008A	; number
         PHA
         JSL   showCHARACTER
         PLY
         PLY
         PLY
         TDC
         CLC
         ADC   #$00FB
         TCS
         PLD
         RTL

*-----------------------------------
* HANDLE MENUS
*-----------------------------------
*
* $F9: word
* $FB: word
* $FD: word
* $FF: word

doMENU
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00E8
         TCS
         LDA   $FB
         CMP   #$0101	; 257 Save
         bne   L014A57
         PEA   ^L030689
         PEA   L030689
         JSL   showDIALOG
         PLY
         PLY
         TAY
         BNE   L014A52
         LDA   $FD
         AND   #$00FF
         PHA
         JSL   doSAVE
         PLY
L014A52  BRL   L014B27

L014A57  CMP   #$0102	; 258 Load
         bne   L014A88
         PEA   ^L0306BD
         PEA   L0306BD
         JSL   showDIALOG
         PLY
         PLY
         TAY
         BNE   L014A83
*         JSL   hideMENUBAR
         LDA   $FF
         AND   #$00FF
         PHA
         LDA   $FD
         AND   #$00FF
         PHA
         JSL   doLOAD
         PLY
         PLY
L014A83  BRL   L014B27

L014A88  CMP   #$0103	; 259 Beginning
         bne   L014A9C
         JSL   hideMENUBAR
         JSL   drawGAMEBOARD
         BRL   L014B27

L014A9C  CMP   #$0104	; 260 Replay
         bne   L014ACC
         LDA   replaySTEP
         BEQ   L014AC7
         PEA   ^L03078D
         PEA   L03078D
         JSL   showDIALOG
         PLY
         PLY
         TAY
         BEQ   L014AC7
         LDA   fgMENUBAR
         BEQ   L014AC3
         JSL   hideMENUBAR
L014AC3  JSL   doREPLAY
L014AC7  BRL   L014B27

L014ACC  CMP   #$0105	; 261 Quit
         bne   L014ADC
         JSL   doQUIT
         BRL   L014B27

L014ADC  CMP   #$0106	; 262 Sound on
         bne   L014AEC
         JSL   doSOUNDON
         BRL   L014B27

L014AEC  CMP   #$0107	; 263 Sound off
         bne   L014AFB
         JSL   doSOUNDOFF
         BRA   L014B27

L014AFB  CMP   #$0109	; 265 About
         bne   L014B27
         JSL   doABOUT

L014B27  LDA   fgMENUBAR
         BEQ   L014B3B
         PEI   $F9
         _HiliteMenu
L014B3B  TDC
         CLC
         ADC   #$00F3
         TCS
         PLD
         RTL

*-----------------------------------
* CHECK EVENT OR REPLAY
*-----------------------------------
* Check a click or a key-press, the menu
* interactions, or replay an action

* $FF: 0000/0001

checkEVENT
         PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00EA
         TCS
         LDA   fgREPLAY
         BEQ   L014B56
         BRL   L014CE8	; we're replaying, restore X/Y

L014B56  LDA   #$0001
         SEP   #$20
         STA   $EF
         REP   #$20

L014B5F  PEA   $0000
         TDC
         CLC
         ADC   #$00F1
         PHA
         _GetMouse

         LDA   fgMENUBAR	; is menu bar visible?
         BNE   L014B8B	; yes

*        lda	$F1
*	cmp	#$000d
*	bcs	L014B8B
	
         LDA   $F1
         SEC
         SBC   #$000D
         BVS   L014B85
         EOR   #$8000
L014B85  BMI   L014B8B
         JSL   showMENUBAR

L014B8B  LDA   fgMENUBAR	; is menu bar visible?
         BEQ   L014BA6	; no

         LDA   $F1
         SEC
         SBC   #$000D
         BEQ   L014BA6
         BVS   L014BA0
         EOR   #$8000
L014BA0  BPL   L014BA6
         JSL   hideMENUBAR

L014BA6	jsl	checkREPLAY

	PHA
         PEA   $FFFF	; all events
         PEA   ^eventREC
         PEA   eventREC
         _GetNextEvent
         PLA
*         SEP   #$20
*         STA   $F5
*         REP   #$20
*         LDA   $F5
*         AND   #$00FF
         BEQ   L014B5F

         LDA   oWHAT
         CMP   #$0001
         BEQ   L014BD4
         BRL   L014C36

*--- mouse-down event

L014BD4  LDA   fgMENUBAR
         BNE   L014BEF
	
         LDA   oWHEREY
         SEC
         SBC   #$000D
         BVS   L014BE9
         EOR   #$8000
L014BE9  BMI   L014BEF
         JSL   showMENUBAR

L014BEF  PEA   ^eventREC
         PEA   eventREC
         PEA   $0000
         PEA   $0000
         _MenuSelect

         LDA   L030995
         BEQ   L014C2B

         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $FF
         AND   #$00FF
         PHA
         LDA   L030995
         PHA
         LDA   L030997
         PHA
         JSL   doMENU
         PLY
         PLY
         PLY
         PLY
         BRA   L014C9A

L014C2B  SEP   #$20
         STZ   $EF
         REP   #$20
         BRA   L014C9A

*--- key-down + auto-key event

L014C36  CMP   #$0003
         BEQ   L014C43
         CMP   #$0005
         bne   L014C9A

L014C43  LDA   oMODIFIERS
         AND   #$0100
         TAY
         beq   L014C9A
         LDA   fgMENUBAR
         BNE   L014C5C
         JSL   showMENUBAR
L014C5C  PEA   ^eventREC
         PEA   eventREC
         PEA   $0000
         PEA   $0000
         _MenuKey
         LDA   L030995
         BEQ   L014C9A
         LDA   $F0
         AND   #$00FF
         PHA
         LDA   $FF
         AND   #$00FF
         PHA
         LDA   L030995
         PHA
         LDA   L030997
         PHA
         JSL   doMENU
         PLY
         PLY
         PLY
         PLY

L014C9A  LDA   $EF
         AND   #$00FF
         BEQ   L014CA9
         LDA   fgREPLAY
         BNE   L014CA9
         BRL   L014B56

L014CA9  LDA   fgREPLAY	; is replay activated?
         BNE   L014CBF	; yes, store the point

         LDA   replaySTEP
         SEC
         SBC   #nbREPLAY	; nb replay steps
         BVS   L014CBA
         EOR   #$8000
L014CBA  BPL   L014CBF
         STZ   replaySTEP

L014CBF  LDA   replaySTEP	; store X/Y in the replay buffer
         PHA
         INC
         STA   replaySTEP
         PLA
         ASL
         TAX
         LDA   oWHEREX
         STA   replayBUFFER,X
         LDA   replaySTEP
         PHA
         INC
         STA   replaySTEP
         PLA
         ASL
         TAX
         LDA   oWHEREY
         STA   replayBUFFER,X
         BRL   L014D27

L014CE8  LDA   replayINDEX	; we're playing from the replay buffer
         PHA
         INC
         STA   replayINDEX
         PLA
         ASL
         TAX
         LDA   replayBUFFER,X
         STA   oWHEREX
         LDA   replayINDEX
         PHA
         INC
         STA   replayINDEX
         PLA
         ASL
         TAX
         LDA   replayBUFFER,X
         STA   oWHEREY

         JSL   regulateSPEED	; do something with the mouse

         LDA   replayINDEX
         SEC
         SBC   replaySTEP
         BVS   L014D1E
         EOR   #$8000
L014D1E  BPL   L014D27

         STZ   fgREPLAY	; we reached first replay data
         _InitCursor

L014D27  LDA   fgCGCOND
         AND   #$00FF
         TAY
         TDC
         CLC
         ADC   #$00F9
         TCS
         TYA
         PLD
         RTL

*----------------------------
* TWILIGHToff
*  Turns Twilight II off
*
* Entry:
*  n/a
*
* Exit:
*  n/a
*
*----------------------------

Debut	=	$00
Arrivee	=	Debut+4

lenV1	=	$49bf
lenV2	=	$539a

offV1	=	$117a
offV2	=	$154c

TWILIGHToff
	phd
	lda	myDP
	tcd

	ldal	$e11600
	sta	Debut
	ldal	$e11602
	sta	Debut+2

TWILIGHToff1
	ldy	#8
	lda	[Debut],y
	ldx	#offV1
	cmp	#lenV1
	beq	TWILIGHToff2
	ldx	#offV2
	cmp	#lenV2
	bne	TWILIGHToff3
	
TWILIGHToff2
	stx	offTWILIGHT
         
	lda	[Debut]
	sta	Arrivee
	sta	ptrTWILIGHT
	ldy	#2
	lda	[Debut],y
	sta	Arrivee+2
	sta	ptrTWILIGHT+2

	txy
	lda	[Arrivee],y
	cmp	#$0ef0
	bne	TWILIGHToff3
	lda	#$0e80
	sta	[Arrivee],y
	inc	fgTWILIGHT
	pld
	rtl

TWILIGHToff3
	ldy	#16
	lda	[Debut],y
	tax
	iny
	iny
	lda	[Debut],y
	sta	Debut+2
	txa
	sta	Debut

	lda	Debut
	ora	Debut+2
	bne	TWILIGHToff1
	pld
	rtl

*----------------------------
* TWILIGHTon
*  Turns Twilight II on
*
* Entry:
*  n/a
*
* Exit:
*  n/a
*
*----------------------------

TWILIGHTon
	lda	fgTWILIGHT
	bne	TWILIGHTon1
	rtl

TWILIGHTon1
	phd
	lda	myDP
	tcd

	lda	ptrTWILIGHT
	sta	Arrivee
	lda	ptrTWILIGHT+2
	sta	Arrivee+2
	ldy	offTWILIGHT
	lda	#$0ef0
	sta	[Arrivee],y
	
	pld
	rtl

*--- Twilight II

ptrTWILIGHT	ds	4
fgTWILIGHT	ds	2
offTWILIGHT	ds	2

*-----------------------------------
* APW LIBRARY STARTS HERE
*-----------------------------------

L014D37  PHD
         TSC		; stack pointer
         TCD
         STA   [$06]	; save it
         LDA   $01,S	; save our calling addresses
         LDY   #$0002
         STA   [$06],Y
         LDA   $02,S
         INY
         INY
         STA   [$06],Y
         LDA   $04,S
         INY
         INY
         STA   [$06],Y
         PLD
         LDA   #$0000
         RTL

*-----------------------------------
* WRITE DATA
*-----------------------------------

writeDATA
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00DA
         TCS
         LDX   $FD
         LDA   $FB
         STX   $EC
         STA   $EA
         LDA   $FF
         BNE   L014D70
         BRL   L014E70
L014D70  LDA   $F9
         CMP   #$8300
         BNE   L014D8B
         PEI   $FF
         PEI   $FD
         PEI   $FB
         JSL   writeCONSOLE
         PLY
         PLY
         PLY
         LDA   $FF
         STA   $EE
         BRL   L014E6E
L014D8B  LDA   $F9
         CMP   #$82FF
         BNE   L014D9A
         LDA   #$FFFF
         STA   $EE
         BRL   L014E6E
L014D9A  LDA   $F9
         CMP   #$82FE
         BNE   L014DCA
         LDA   $FF
         STA   $EE
L014DA5  LDA   $FF
         DEC   $FF
         TAY
         BEQ   L014DC7
         LDX   $FD
         LDA   $FB
         INC   $FB
         BNE   L014DB6
         INC   $FD
L014DB6  STA   $F0
         STX   $F2
         LDA   [$F0]
         AND   #$00FF
         PHA
         JSL   L015B57
         PLY
         BRA   L014DA5
L014DC7  BRL   L014E6E
L014DCA  PEI   $F9
         JSL   L0152A6
         PLY
         TAY
         BNE   L014DF6
L014DD4  LDA   $EE
         DEC   $EE
         TAY
         BEQ   L014DF6
         LDA   [$EA]
         AND   #$00FF
         CMP   #$000A
         BNE   L014DEE
         LDA   #$000D
         SEP   #$20
         STA   [$EA]
         REP   #$20
L014DEE  INC   $EA
         BNE   L014DF4
         INC   $EC
L014DF4  BRA   L014DD4
L014DF6  LDA   $F9
         STA   $DC
         LDX   $FD
         LDA   $FB
         STX   $E0
         STA   $DE
         LDA   $FF
         LDX   #$0000
         STX   $E4
         STA   $E2
         PEA   $0000
         TDC
         CLC
         ADC   #$00DC
         PHA
         JSL   writeFILE
         PLY
         PLY
         LDA   errCODE
         BEQ   L014E38
         LDA   errCODE
         CMP   #$004C
         BNE   L014E2B
         STZ   $EE
         BRA   L014E36
L014E2B  LDA   errCODE
         STA   errCODE2
         LDA   #$FFFF
         STA   $EE
L014E36  BRA   L014E3E
L014E38  LDX   $E8
         LDA   $E6
         STA   $EE
L014E3E  PEI   $F9
         JSL   L0152A6
         PLY
         TAY
         BNE   L014E6E
         LDA   $EE
         STA   $FF
L014E4C  LDA   $FF
         DEC   $FF
         TAY
         BEQ   L014E6E
         LDA   [$FB]
         AND   #$00FF
         CMP   #$000D
         BNE   L014E66
         LDA   #$000A
         SEP   #$20
         STA   [$FB]
         REP   #$20
L014E66  INC   $FB
         BNE   L014E6C
         INC   $FD
L014E6C  BRA   L014E4C
L014E6E  LDA   $EE

L014E70  TAY
         TDC
         CLC
         ADC   #$00F3
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* WRITE CONSOLE
*-----------------------------------

writeCONSOLE
         PHD
         TSC
         SEC
         SBC   #$00F5
         TCD
         ADC   #$00EE
         TCS
         LDX   #$0000
         LDA   #$C000
         STA   $F2
         STX   $F4
         LDA   [$F2]
         AND   #$00FF
         PHA
         LDX   #$0000
         LDA   #$C010
         STA   $F2
         STX   $F4
         LDA   [$F2]
         AND   #$00FF
         PLX
         STX   $F2
         CMP   $F2
         BEQ   L014F03
L014EAB  LDX   #$0000
         LDA   #$C010
         STA   $F2
         STX   $F4
         LDA   [$F2]
         AND   #$00FF
         SEC
         SBC   #$007F
         BEQ   L014EC9
         BVS   L014EC5
         EOR   #$8000
L014EC5  BPL   L014EC9
         BRA   L014EAB
L014EC9  LDX   #$0000
         LDA   #$C010
         STA   $F2
         STX   $F4
         LDA   [$F2]
         AND   #$00FF
         SEC
         SBC   #$0080
         BVS   L014EE1
         EOR   #$8000
L014EE1  BMI   L014EE5
         BRA   L014EC9
L014EE5  LDX   #$0000
         LDA   #$C010
         STA   $F2
         STX   $F4
         LDA   [$F2]
         AND   #$00FF
         SEC
         SBC   #$007F
         BEQ   L014F03
         BVS   L014EFF
         EOR   #$8000
L014EFF  BPL   L014F03
         BRA   L014EE5
L014F03  LDA   $FF
         DEC   $FF
         TAY
         BEQ   L014F50
         LDA   [$FB]
         AND   #$00FF
         CMP   #$000A
         BNE   L014F30
         PEA   $000D
         _WriteChar
         PEA   $000A
         _WriteChar
         BRA   L014F4E
L014F30  LDX   $FD
         LDA   $FB
         INC   $FB
         BNE   L014F3A
         INC   $FD
L014F3A  STA   $F2
         STX   $F4
         LDA   [$F2]
         AND   #$00FF
         PHA
         _WriteChar
L014F4E  BRA   L014F03
L014F50  TDC
         CLC
         ADC   #$00F5
         TCS
         PLD
         RTL

*-----------------------------------
* COPY C STRING
*-----------------------------------

* copyCSTRING(*source, *dest)
* F9 DEST
* FD SOURCE

copyCSTRING
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
L014F6B	lda	[$fd]
	and	#$00ff
	sep	#$20
	sta	[$f9]
	rep	#$20
	beq	L014F9B
	inc	$fd	; *source++
	bne	L014F75
	inc	$ff
L014F75	inc	$f9	; *dest++
	bne	L014F6B
	inc	$fb
	bne	L014F6B
L014F9B  TDC
         CLC
         ADC   #$00F3
         TCS
         PLD
         RTL

*-----------------------------------
* APPEND C STRING
*-----------------------------------
* appendCSTRING(*source, *dest)
* F9 DEST
* FD SOURCE

appendCSTRING
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
L014FBC	lda	[$f9]	; find the end of the destination string
	and	#$00ff
	beq	L014FD9
	inc	$f9
	bne	L014FBC
	inc	$fb
	bne	L014FBC
L014FD9	lda	[$fd]
	and	#$00ff
	sep	#$20
	sta	[$f9]
	rep	#$20
	beq	L015009
	inc	$fd	; *source++
	bne	L014FF7
	inc	$ff
L014FF7	inc	$f9	; *dest++
	bne	L014FD9
	inc	$fb
	bne	L014FD9
L015009  TDC
         CLC
         ADC   #$00F3
         TCS
         PLD
         RTL

*-----------------------------------
* READ DATA
*-----------------------------------
* Bug: it reads <64K, so I patched it (bad bad)

readDATA
         PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00DA
         TCS
         LDX   $FD
         LDA   $FB
         STX   $EC
         STA   $EA
         LDA   $F9
         CMP   #$8300
         BNE   L015071
         STZ   $EE
L015033  LDA   $FF
         DEC   $FF
         TAY
         BEQ   L01505F
         PEI   $F9
         JSL   readCONSOLE
         PLY
         PHA
         PLA
         SEP   #$20
         STA   [$EA]
         REP   #$20
         AND   #$00FF
         CMP   #$FFFF
         BNE   L015055
         BRA   L01505F
         BRA   L01505D
L015055  INC   $EA
         BNE   L01505B
         INC   $EC
L01505B  INC   $EE
L01505D  BRA   L015033
L01505F  LDA   $EE
         BNE   L015069
         LDA   #$FFFF
         BRL   L01512A
L015069  LDA   $EE
         BRL   L01512A
         BRL   L0150F8
L015071  LDA   $F9
         CMP   #$82FF
         BNE   L015080
         LDA   #$FFFF
         STA   $EE
         BRL   L0150F8
L015080  LDA   $F9
         CMP   #$82FE
         BNE   L0150B0
         LDA   $FF
         STA   $EE
L01508B  LDA   $FF
         DEC   $FF
         TAY
         BEQ   L0150AE
         JSL   L015B81
         PHA
         LDX   $EC
         LDA   $EA
         INC   $EA
         BNE   L0150A1
         INC   $EC
L0150A1  STA   $F0
         STX   $F2
         PLA
         SEP   #$20
         STA   [$F0]
         REP   #$20
         BRA   L01508B
L0150AE  BRA   L0150F8
L0150B0  LDA   $F9	; $DC (word): fileRefNum
         STA   $DC	; $DE (long): dataBuffer
         LDX   $FD	; $E2 (long): requestCount
         LDA   $FB	; $E6 (long): transferCount
         STX   $E0
         STA   $DE
         LDA   $FF
patchREAD
         LDX   #$0000	; cannot read more than 64K
         STX   $E4
         STA   $E2
         PEA   $0000
         TDC
         CLC
         ADC   #$00DC
         PHA
         JSL   readFILE
         PLY
         PLY
         LDA   errCODE
         BEQ   L0150F2
         LDA   errCODE
         CMP   #$004C
         BNE   L0150E5
         STZ   $EE
         BRA   L0150F0
L0150E5  LDA   errCODE
         STA   errCODE2
         LDA   #$FFFF
         STA   $EE
L0150F0  BRA   L0150F8
L0150F2  LDX   $E8
         LDA   $E6
         STA   $EE
L0150F8  PEI   $F9
         JSL   L0152A6
         PLY
         TAY
         BNE   L015128
         LDA   $EE
         STA   $FF
L015106  LDA   $FF
         DEC   $FF
         TAY
         BEQ   L015128
         LDA   [$FB]
         AND   #$00FF
         CMP   #$000D
         BNE   L015120
         LDA   #$000A
         SEP   #$20
         STA   [$FB]
         REP   #$20
L015120  INC   $FB
         BNE   L015126
         INC   $FD
L015126  BRA   L015106
L015128  LDA   $EE
L01512A  TAY
         TDC
         CLC
         ADC   #$00F3
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* READ CONSOLE
*-----------------------------------

readCONSOLE
         PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F2
         TCS
         LDA   $FF
         CMP   #$8300
         BEQ   L015149
         BRL   L01529C
L015149  LDA   charINDEX
         CMP   charINDEX2
         BEQ   L015154
         BRL   L015276
L015154  LDA   #$0000
         STA   charINDEX2
         STA   charINDEX
L01515D  LDA   #$0001
         BNE   L015165
         BRL   L015258
L015165  PHA
         PEA   $0000
         _ReadChar
         PLA
         AND   #$007F
         STA   $F4
         LDA   $F4
         CMP   #$0008
         BNE   L0151B2
         LDA   charINDEX
         BEQ   L0151AF
         DEC   charINDEX
         PEA   $0008
         _WriteChar
         PEA   $0020
         _WriteChar
         PEA   $0008
         _WriteChar
L0151AF  BRL   L015255
L0151B2  LDA   $F4
         CMP   #$000D
         BNE   L0151EB
         LDA   charINDEX
         PHA
         INC
         STA   charINDEX
         PLA
         TAX
         LDA   #$000A
         SEP   #$20
         STA   L0332E9,X
         REP   #$20
         PEA   $000D
         _WriteChar
         PEA   $000A
         _WriteChar
         BRL   L015258
L0151EB  LDA   $F4
         CMP   #$0003
         BNE   L0151FA
         PEA   $0002
         JSL   L015BB0
         PLY
L0151FA  LDA   $F4
         CMP   #$001A
         BNE   L015233
         LDA   $F4
         PHA
         LDA   charINDEX
         PHA
         INC
         STA   charINDEX
         PLA
         TAX
         PLA
         SEP   #$20
         STA   L0332E9,X
         REP   #$20
         PEA   $000D
         _WriteChar
         PEA   $000A
         _WriteChar
         BRA   L015258
L015233  LDA   $F4
         PHA
         LDA   charINDEX
         PHA
         INC
         STA   charINDEX
         PLA
         TAX
         PLA
         SEP   #$20
         STA   L0332E9,X
         REP   #$20
         PEI   $F4
         _WriteChar
L015255  BRL   L01515D
L015258  LDX   #$0000
         LDA   #$C010
         STA   $F6
         STX   $F8
         LDA   [$F6]
         AND   #$00FF
         SEC
         SBC   #$007F
         BEQ   L015276
         BVS   L015272
         EOR   #$8000
L015272  BPL   L015276
         BRA   L015258
L015276  LDA   charINDEX2
         TAX
         LDA   L0332E9,X
         AND   #$00FF
         CMP   #$001A
         BNE   L01528B
         LDA   #$FFFF
         BRA   L01529C
L01528B  LDA   charINDEX2
         PHA
         INC
         STA   charINDEX2
         PLA
         TAX
         LDA   L0332E9,X
         AND   #$00FF
L01529C  TAY
         TDC
         CLC
         ADC   #$00F9
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L0152A6  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00EC
         TCS
         LDA   #^L033339
         STA   $F4
         LDA   #L033339
         STA   $F2
         LDY   #$0080
L0152C2  LDA   [$F2],Y
         CMP   $FF
         BEQ   L0152D2
         DEY
         DEY
         DEY
         DEY
         DEY
         DEY
         DEY
         DEY
         BPL   L0152C2
L0152D2  INY
         INY
         LDA   [$F2],Y
         TAY
         TDC
         CLC
         ADC   #$00F9
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* OPEN DATA
*-----------------------------------

openDATA
         PHD
         TSC
         SEC
         SBC   #$00F5
         TCD
         ADC   #$00DE
         TCS
         STZ   $EE
         PEA   ^L0333B9
         PEA   L0333B9
         PEI   $FD
         PEI   $FB
         JSL   L015CBB
         PLY
         PLY
         PLY
         PLY
         TAY
         BNE   L01530E
         LDA   #$8300
         STA   $F0
         BRL   L015398
L01530E  PEA   ^L0333BE
         PEA   L0333BE
         PEI   $FD
         PEI   $FB
         JSL   L015CBB
         PLY
         PLY
         PLY
         PLY
         TAY
         BNE   L01532B
         LDA   #$82FF
         STA   $F0
         BRL   L015398
L01532B  PEA   ^L0333C3
         PEA   L0333C3
         PEI   $FD
         PEI   $FB
         JSL   L015CBB
         PLY
         PLY
         PLY
         PLY
         TAY
         BNE   L01534B
         JSL   L015B2B
         LDA   #$82FE
         STA   $F0
         BRA   L015398
L01534B  LDX   $FD
         LDA   $FB
         STX   $E4
         STA   $E2
         LDX   #$0000
         LDA   #$0000
         STX   $E8
         STA   $E6
         PEA   $0000
         TDC
         CLC
         ADC   #$00E0
         PHA
         JSL   openFILE
         PLY
         PLY
         LDA   errCODE
         BEQ   L01537E
         LDA   errCODE
         STA   errCODE2
         LDA   #$FFFF
         STA   $F0
         BRA   L015398
L01537E  LDA   $E0
         STA   $F0
         LDY   #$0002
         LDA   [$E6],Y
         TAX
         LDA   [$E6]
         PHX
         PHA
         PEI   $FF
         PEI   $F0
         JSL   L0153A4
         PLY
         PLY
         PLY
         PLY
L015398  LDA   $F0
         TAY
         TDC
         CLC
         ADC   #$00F5
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L0153A4  PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00EC
         TCS
         STZ   $EE
         BRA   L015403
L0153B3  LDA   $EE
         ASL
         ASL
         ASL
         TAX
         LDA   L033339,X
         BNE   L015401
         LDA   $EE
         ASL
         ASL
         ASL
         TAX
         LDA   $F9
         STA   L033339,X
         LDA   $EE
         ASL
         ASL
         ASL
         TAX
         LDA   $FB
         STA   L03333B,X
         LDA   $EE
         ASL
         ASL
         ASL
         PHA
         LDA   #L03333D
         STA   $F0
         LDA   #^L03333D
         STA   $F2
         PLA
         CLC
         ADC   $F0
         STA   $F0
         BCC   L0153F1
         INC   $F2
L0153F1  LDX   $FF
         LDA   $FD
         LDY   #$0002
         PHA
         TXA
         STA   [$F0],Y
         PLA
         STA   [$F0]
         BRA   L015410
L015401  INC   $EE
L015403  LDA   $EE
         SEC
         SBC   #$0010
         BVS   L01540E
         EOR   #$8000
L01540E  BPL   L0153B3
L015410  TDC
         CLC
         ADC   #$00F3
         TCS
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015418  PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00D4
         TCS
         STZ   $E2
         LDA   $F9
         SEC
         SBC   #$0000
         BVS   L015430
         EOR   #$8000
L015430  BMI   L01543B
         LDX   #$FFFF
         LDA   #$FFFF
         BRL   L015570
L01543B  LDA   $F9
         STA   $D6
         PEA   $0000
         TDC
         CLC
         ADC   #$00D6
         PHA
         JSL   geteofFILE
         PLY
         PLY
         LDA   errCODE
         BEQ   L015462
         LDA   errCODE
         STA   errCODE2
         LDX   #$FFFF
         LDA   #$FFFF
         BRL   L015570
L015462  LDX   $DA
         LDA   $D8
         STX   $EA
         STA   $E8
         LDA   $F9
         STA   $DC
         PEA   $0000
         TDC
         CLC
         ADC   #$00DC
         PHA
         JSL   getmarkFILE
         PLY
         PLY
         LDA   errCODE
         BEQ   L01548B
         LDX   #$FFFF
         LDA   #$FFFF
         BRL   L015570
L01548B  LDX   $E0
         LDA   $DE
         STX   $EE
         STA   $EC
         LDA   $FF
         CMP   #$0000
         BEQ   L01549C
         BRA   L0154A8
L01549C  LDX   $FD
         LDA   $FB
         STX   $E6
         STA   $E4
         BRA   L0154ED
         BRA   L0154AF
L0154A8  CMP   #$0001
         BEQ   L0154AF
         BRA   L0154C4
L0154AF  LDX   $EE
         LDA   $EC
         CLC
         ADC   $FB
         PHA
         TXA
         ADC   $FD
         TAX
         PLA
         STX   $E6
         STA   $E4
         BRA   L0154ED
         BRA   L0154CB
L0154C4  CMP   #$0002
         BEQ   L0154CB
         BRA   L0154EB
L0154CB  LDX   $EA
         LDA   $E8
         CLC
         ADC   $FB
         PHA
         TXA
         ADC   $FD
         TAX
         PLA
         STX   $E6
         STA   $E4
         BRA   L0154ED
L0154DE  LDX   #$FFFF
         LDA   #$FFFF
         BRL   L015570
         BRA   L0154ED
         BRA   L0154ED
L0154EB  BRA   L0154DE
L0154ED  LDX   $EA
         LDA   $E8
         PHX
         PHA
         LDX   $E6
         LDA   $E4
         JSL   subtract32BIT
         BVS   L015500
         EOR   #$8000
L015500  BMI   L015546
         LDX   $EA
         LDA   $E8
         STX   $E0
         STA   $DE
         PEA   $0000
         TDC
         CLC
         ADC   #$00DC
         PHA
         JSL   setmarkFILE
         PLY
         PLY
         LDX   $E6
         LDA   $E4
         SEC
         SBC   $E8
         PHA
         TXA
         SBC   $EA
         TAX
         PLA
         PHX
         PHA
         PEA   $0000
         TDC
         CLC
         ADC   #$00E4
         PHA
         PEI   $F9
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         PLY
         CMP   #$FFFF
         BNE   L015544
         INC   errCODE
L015544  BRA   L01555D
L015546  LDX   $E6
         LDA   $E4
         STX   $E0
         STA   $DE
         PEA   $0000
         TDC
         CLC
         ADC   #$00DC
         PHA
         JSL   setmarkFILE
         PLY
         PLY
L01555D  LDA   errCODE
         BEQ   L01556C
         LDX   #$FFFF
         LDA   #$FFFF
         STX   $E6
         STA   $E4
L01556C  LDX   $E6
         LDA   $E4
L015570  TAY
         TDC
         CLC
         ADC   #$00F3
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L01557A  PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00D0
         TCS
         LDA   $FF
         STA   $EC
         LDA   $FD
         AND   #$0004
         TAY
         BNE   L015596
         LDA   #$0004
         STA   $EC
L015596  PEA   ^L0333C8	; CON:
         PEA   L0333C8
         PEI   $FB
         PEI   $F9
         JSL   L015CBB
         PLY
         PLY
         PLY
         PLY
         TAY
         BNE   L0155AE
         BRL   L015641
L0155AE  PEA   ^L0333CD	; PRT:
         PEA   L0333CD
         PEI   $FB
         PEI   $F9
         JSL   L015CBB
         PLY
         PLY
         PLY
         PLY
         TAY
         BNE   L0155C6
         BRL   L015641
L0155C6  PEA   ^L0333D2	; AUX:
         PEA   L0333D2
         PEI   $FB
         PEI   $F9
         JSL   L015CBB
         PLY
         PLY
         PLY
         PLY
         TAY
         BEQ   L015641
         PEI   $FB
         PEI   $F9
         JSL   L015C7B
         PLY
         PLY
         LDX   $FB
         LDA   $F9
         STX   $D4
         STA   $D2
         LDA   #$00C3	; access
         STA   $D6
         LDA   #$005d	; file type (was LDA $EC)
         STA   $D8
	lda   #$801a	; auxtype
         sta   $DA
         stz   $DC
         LDA   #$0001	; storage type
         STA   $DE
         stz   $E0	; create date
         stz   $E2	; create time
         PEA   $0000
         TDC
         CLC
         ADC   #$00D2
         PHA
         JSL   createFILE
         PLY
         PLY
         LDA   errCODE
         BEQ   L015630
         LDA   #$FFFF
         STA   $EE
         LDA   errCODE
         STA   errCODE2
         BRA   L01563F
L015630  PEI   $FD
         PEI   $FB
         PEI   $F9
         JSL   openDATA
         PLY
         PLY
         PLY
         STA   $EE
L01563F  BRA   L015646
L015641  LDA   #$FFFF
         STA   $EE
L015646  LDA   $EE
         TAY
         TDC
         CLC
         ADC   #$00F3
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015652  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00E2
         TCS
         STZ   $F4
         LDA   $FF
         SEC
         SBC   #$0000
         BEQ   L0156BC
         BVS   L01566C
         EOR   #$8000
L01566C  BPL   L0156BC
         STZ   $F2
         BRA   L015685
L015672  LDA   $F2
         ASL
         ASL
         ASL
         TAX
         LDA   $FF
         STA   L033339,X
         TAY
         BEQ   L015683
         BRA   L015692
L015683  INC   $F2
L015685  LDA   $F2
         SEC
         SBC   #$0010
         BVS   L015690
         EOR   #$8000
L015690  BPL   L015672
L015692  PEI   $FF
         JSL   L015D08
         PLY
         LDA   $FF
         STA   $E4
         PEA   $0000
         TDC
         CLC
         ADC   #$00E4
         PHA
         JSL   closeFILE
         PLY
         PLY
         LDA   errCODE
         BEQ   L0156BC
         LDA   #$FFFF
         STA   $F4
         LDA   errCODE
         STA   errCODE2
L0156BC  LDA   $F4
         TAY
         TDC
         CLC
         ADC   #$00F9
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* MULTIPLY 16x16
*-----------------------------------

multiply16BIT
         PHD
         PHA
         TSC
         TCD
         LDX   #$0000
         BCC   L015774
         LDA   $01
         BIT   #$8000
         BEQ   L015766
         EOR   #$FFFF
         INC
         STA   $01
         INX
L015766  LDA   $08
         BIT   #$8000
         BEQ   L015774
         EOR   #$FFFF
         INC
         STA   $08
         DEX
L015774  LDA   #$0000
         BRA   L015782
L015779  LSR   $08
         BCC   L015780
         CLC
         ADC   $01
L015780  ASL   $01
L015782  LDY   $08
         BNE   L015779
         CPX   #$0000
         BEQ   L01578F
         EOR   #$FFFF
         INC
L01578F  STA   $08
         PLY
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015794  PHD
         PHA
         PEA   $0001
         TSC
         TCD
         LDX   #$0000
         BCC   L0157BC
         LDA   $03
         BIT   #$8000
         BEQ   L0157AE
         EOR   #$FFFF
         INC
         STA   $03
         INX
L0157AE  LDA   $0A
         BIT   #$8000
         BEQ   L0157BC
         EOR   #$FFFF
         INC
         STA   $0A
         DEX
L0157BC  LDY   #$0000
         BRA   L0157C3
L0157C1  ASL   $01
L0157C3  ASL   $03
         BCC   L0157C1
         ROR   $03
L0157C9  LDA   $0A
         CMP   $03
         BCC   L0157DA
         LDA   $0A
         SEC
         SBC   $03
         STA   $0A
         TYA
         ORA   $01
         TAY
L0157DA  LSR   $03
         LSR   $01
         BCC   L0157C9
         TYA
         CPX   #$0000
         BEQ   L0157EA
         EOR   #$FFFF
         INC
L0157EA  PLY
         PLY
         PLD
         RTL

*-----------------------------------
* 32-BIT ADD
*-----------------------------------

add32BIT
         CLC
         ADC   $04,S
         STA   $04,S
         TXA
         ADC   $06,S
         STA   $06,S
         RTL

*-----------------------------------
* 32-BIT SUBTRACT
*-----------------------------------

subtract32BIT
         PHX
         PHA
         LDA   $08,S
         TAX
         LDA   $0A,S
         TAY
         SEP   #$20
         LDA   $07,S
         STA   $0B,S
         LDA   $06,S
         STA   $0A,S
         LDA   $05,S
         STA   $09,S
         REP   #$20
         TXA
         SEC
         SBC   $01,S
         STA   $01,S
         TYA
         SBC   $03,S
         STA   $03,S
         PHP
         BNE   L01582B
         LDA   $02,S
         BEQ   L01582B
         SEP   #$20
         LDA   #$FD
         AND   $01,S
         STA   $01,S
L01582B  SEP   #$20
         LDA   $01,S
         STA   $09,S
         REP   #$20
         LDA   $04,S
         PLY
         PLY
         PLY
         PLY
         PLP
         RTL

*-----------------------------------
* FILE: SET MARK
*-----------------------------------

setmarkFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $0006
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         JSL   GSOS
         DW    $0016      ; SetMark
         ADRL  L0333D7
	STA   errCODE
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: GET EOF
*-----------------------------------

geteofFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $0006
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         JSL   GSOS
         DW    $0019      ; GetEOF
         ADRL  L0333D7
	STA   errCODE
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         LDA   $F4
         LDX   $F6
         PHX
         PHA
         LDA   $FF
         PHA
         LDA   $FD
         PHA
         PEA   $0006
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: WRITE
*-----------------------------------

writeFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $000E
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         JSL   GSOS
         DW    $0013      ; Write
         ADRL  L0333D7
	STA   errCODE
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         LDA   $F4
         LDX   $F6
         PHX
         PHA
         LDA   $FF
         PHA
         LDA   $FD
         PHA
         PEA   $000E
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: CLOSE
*-----------------------------------

closeFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $000E
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         JSL   GSOS
         DW    $0014      ; Close
         ADRL  L0333D7
	STA   errCODE
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: READ
*-----------------------------------

readFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $000E
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         JSL   GSOS
         DW    $0012      ; Read
         ADRL  L0333D7
	STA   errCODE
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         LDA   $F4
         LDX   $F6
         PHX
         PHA
         LDA   $FF
         PHA
         LDA   $FD
         PHA
         PEA   $000E
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: GET MARK
*-----------------------------------

getmarkFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $0006
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         JSL   GSOS
         DW    $0017      ; GetMark
         ADRL  L0333D7
	STA   errCODE
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         LDA   $F4
         LDX   $F6
         PHX
         PHA
         LDA   $FF
         PHA
         LDA   $FD
         PHA
         PEA   $0006
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: CREATE
*-----------------------------------

createFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $001A
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         PHX
         PHA
         JSL   L015D49
         PLY
         PLY
         JSL   GSOS
         DW    $0001      ; Create
         ADRL  L0333D7
	STA   errCODE
         LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         PHX
         PHA
         JSL   L015DB7
         PLY
         PLY
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: OPEN
*-----------------------------------

openFILE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $000A
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         LDY   #$0004
         LDA   [$FD],Y
         TAX
         LDY   #$0002
         LDA   [$FD],Y
         PHX
         PHA
         JSL   L015D49
         PLY
         PLY
         JSL   GSOS
         DW    $0010      ; Open
         ADRL  L0333D7
	STA   errCODE
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         LDA   $F4
         LDX   $F6
         PHX
         PHA
         LDA   $FF
         PHA
         LDA   $FD
         PHA
         PEA   $000A
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         LDY   #$0004
         LDA   [$FD],Y
         TAX
         LDY   #$0002
         LDA   [$FD],Y
         PHX
         PHA
         JSL   L015DB7
         PLY
         PLY
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015B2B  PHA
         PHA
         PHA
         PHA
         LDA   #$0007
         PHA
         PHA
         PHA
         pea   $C200
         _FWEntry
         PLA
         PLA
         PLA
         PLA
         RTL

*-----------------------------------
*
*-----------------------------------

L015B57  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F4
         TCS
         PHA
         PHA
         PHA
         PHA
         PEI   $FF
         PHA
         PHA
         pea   $C207
         _FWEntry
         PLA
         PLA
         PLA
         PLA
         TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015B81  PHA
         PHA
         PHA
         PHA
         PHA
         PHA
         PHA
         pea   $C205
         _FWEntry
         PLA
         PLA
         PLA
         PLY
         RTL

*-----------------------------------
*
*-----------------------------------

L015BB0  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00EE
         TCS
         LDA   #L0333F5
         LDX   #^L0333F5
         STX   $F2
         STA   $F0
         BRA   L015BE8

L015BC7  LDY   #$000A
         LDA   [$F0],Y
         AND   #$0003
         TAY
         BEQ   L015BDC
         PEI   $F2
         PEI   $F0
         JSL   L015E36
         PLY
         PLY
L015BDC  LDA   $F0
         CLC
         ADC   #$0014
         STA   $F0
         BCC   L015BE8
         INC   $F2

L015BE8  pea   $0000
         pea   $00A0
         LDA   #L0333F5
         LDX   #^L0333F5
         JSL   add32BIT
         PLA
         PLX
         PHX
         PHA
         LDX   $F2
         LDA   $F0
         JSL   subtract32BIT
         BEQ   L015C0F
         BVS   L015C0D
         EOR   #$8000
L015C0D  BMI   L015BC7
L015C0F  STZ   $F4
         BRA   L015C3C
L015C13  LDA   $F4
         ASL
         ASL
         ASL
         TAX
         LDA   L033339,X
         SEC
         SBC   #$0000
         BEQ   L015C3A
         BVS   L015C28
         EOR   #$8000
L015C28  BPL   L015C3A
         LDA   $F4
         ASL
         ASL
         ASL
         TAX
         LDA   L033339,X
         PHA
         JSL   L015652
         PLY
L015C3A  INC   $F4
L015C3C  LDA   $F4
         SEC
         SBC   #$0010
         BVS   L015C47
         EOR   #$8000
L015C47  BPL   L015C13
         PEI   $FF
         JSL   L015C58
         PLY
         TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015C58  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F4
         TCS
         PEA   $0001
         PEA   ^L030028
         PEA   L030028
         JSL   L0160B2
         PLY
         PLY
         PLY
         TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015C7B  PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00E8
         TCS
         STZ   $EA	; return code
         LDX   $FF
         LDA   $FD
         STX   $EE
         STA   $EC
         PEA   $0000
         TDC
         CLC
         ADC   #$00EC
         PHA
         JSL   fileDESTROY
         PLY
         PLY
         LDA   errCODE
         BEQ   L015CAF
         LDA   errCODE
         STA   errCODE2
         LDA   #$FFFF
         STA   $EA
L015CAF  LDA   $EA
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015CBB  PHD
         TSC
         SEC
         SBC   #$00F3
         TCD
         ADC   #$00EE
         TCS
         BRA   L015CD4
L015CC8  INC   $F9
         BNE   L015CCE
         INC   $FB
L015CCE  INC   $FD
         BNE   L015CD4
         INC   $FF
L015CD4  LDA   [$F9]
         AND   #$00FF
         BEQ   L015CED
         LDA   [$F9]
         AND   #$00FF
         PHA
         LDA   [$FD]
         AND   #$00FF
         PLX
         STX   $F0
         CMP   $F0
         BEQ   L015CC8
L015CED  LDA   [$FD]
         AND   #$00FF
         PHA
         LDA   [$F9]
         AND   #$00FF
         PLX
         STX   $F0
         SEC
         SBC   $F0
         TAY
         TDC
         CLC
         ADC   #$00F3
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015D08  PHD
         TSC
         SEC
         SBC   #$00F9
         TCD
         ADC   #$00F2
         TCS
         STZ   $F4
         BRA   L015D34
L015D17  LDA   $F4
         ASL
         ASL
         ASL
         TAX
         LDA   L033339,X
         CMP   $FF
         BNE   L015D32
         LDA   $F4
         ASL
         ASL
         ASL
         TAX
         LDA   #$0000
         STA   L033339,X
L015D32  INC   $F4
L015D34  LDA   $F4
         SEC
         SBC   #$0010
         BVS   L015D3F
         EOR   #$8000
L015D3F  BPL   L015D17
         TDC
         CLC
         ADC   #$00F9
         TCS
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015D49  PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00E8
         TCS
         LDX   $FF
         LDA   $FD
         STX   $EC
         STA   $EA
         LDX   $FF
         LDA   $FD
         STX   $F4
         ORA   $F4
         BEQ   L015DA9
L015D66  LDA   [$FD]
         AND   #$00FF
         STA   $EE
         LDA   $F0
         PHA
         LDX   $FF
         LDA   $FD
         INC   $FD
         BNE   L015D7A
         INC   $FF
L015D7A  STA   $F4
         STX   $F6
         PLA
         SEP   #$20
         STA   [$F4]
         REP   #$20
         LDA   $EE
         STA   $F0
         LDA   $EE
         BNE   L015D66
         LDX   $EC
         LDA   $EA
         PHX
         PHA
         LDX   $FF
         LDA   $FD
         JSL   subtract32AX
         PLA
         PLX
         SEC
         SBC   #$0001
         PHA
         PLA
         SEP   #$20
         STA   [$EA]
         REP   #$20
L015DA9  LDX   $FF
         LDA   $FD
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015DB7  PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00E8
         TCS
         LDX   $FF
         LDA   $FD
         STX   $EC
         STA   $EA
         LDX   $FF
         LDA   $FD
         STX   $F4
         ORA   $F4
         BEQ   L015E28
         LDX   $FF
         LDA   $FD
         INC   $FD
         BNE   L015DDE
         INC   $FF
L015DDE  STX   $F0
         STA   $EE
         STA   $F4
         STX   $F6
         LDA   [$F4]
         AND   #$00FF
         STA   $F2
         BRA   L015E18
L015DEF  LDX   $FF
         LDA   $FD
         INC   $FD
         BNE   L015DF9
         INC   $FF
L015DF9  STA   $F4
         STX   $F6
         LDA   [$F4]
         AND   #$00FF
         PHA
         LDX   $F0
         LDA   $EE
         INC   $EE
         BNE   L015E0D
         INC   $F0
L015E0D  STA   $F4
         STX   $F6
         PLA
         SEP   #$20
         STA   [$F4]
         REP   #$20
L015E18  LDA   $F2
         DEC   $F2
         TAY
         BNE   L015DEF
         LDA   #$0000
         SEP   #$20
         STA   [$EE]
         REP   #$20
L015E28  LDX   $EC
         LDA   $EA
         TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015E36  PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         PEI   $FF
         PEI   $FD
         JSL   L015E99
         PLY
         PLY
         TAY
         BEQ   L015E53
         LDA   #$FFFF
         BRA   L015E8F
L015E53  LDY   #$000A
         LDA   [$FD],Y
         AND   #$0010
         TAY
         BEQ   L015E71
         LDY   #$0008
         LDA   [$FD],Y
         TAX
         LDY   #$0006
         LDA   [$FD],Y
         PHX
         PHA
         JSL   findDISPOSEHANDLE
         PLY
         PLY
L015E71  LDA   #$0000
         LDY   #$000A
         STA   [$FD],Y
         LDY   #$000C
         LDA   [$FD],Y
         PHA
         JSL   L015652
         PLY
         TAY
         BEQ   L015E8C
         LDA   #$FFFF
         BRA   L015E8F
L015E8C  LDA   #$0000
L015E8F  TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L015E99  PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F0
         TCS
         LDY   #$000A
         LDA   [$FD],Y
         AND   #$0003
         TAY
         BNE   L015EB5
         LDA   #$FFFF
         BRL   L015FE1
L015EB5  LDY   #$0008
         LDA   [$FD],Y
         TAX
         LDY   #$0006
         LDA   [$FD],Y
         PHX
         PHA
         LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         JSL   subtract32AX
         PLA
         PLX
         STA   $F2
         LDY   #$000A
         LDA   [$FD],Y
         AND   #$0080
         TAY
         BNE   L015EE0
         BRL   L015F77
L015EE0  LDY   #$000A
         LDA   [$FD],Y
         AND   #$0002
         TAY
         BNE   L015EF1
         LDA   #$FFFF
         BRL   L015FE1
L015EF1  LDY   #$000A
         LDA   [$FD],Y
         AND   #$0004
         TAY
         BEQ   L015F13
         PEA   $0002
         PEA   $0000
         PEA   $0000
         LDY   #$000C
         LDA   [$FD],Y
         PHA
         JSL   L015418
         PLY
         PLY
         PLY
         PLY
L015F13  PEI   $F2
         LDY   #$0008
         LDA   [$FD],Y
         TAX
         LDY   #$0006
         LDA   [$FD],Y
         PHX
         PHA
         LDY   #$000C
         LDA   [$FD],Y
         PHA
         JSL   writeDATA
         PLY
         PLY
         PLY
         PLY
         CMP   #$FFFF
         BNE   L015F3B
         LDA   #$FFFF
         BRL   L015FE1
L015F3B  LDY   #$000A
         LDA   [$FD],Y
         AND   #$FF7F
         PHA
         PLA
         LDY   #$000A
         STA   [$FD],Y
         LDA   $F2
         LDX   #$0000
         TAY
         BPL   L015F53
         DEX
L015F53  PHX
         PHA
         LDY   #$0010
         LDA   [$FD],Y
         TAX
         LDY   #$000E
         LDA   [$FD],Y
         JSL   add32BIT
         PLA
         PLX
         PHA
         PLA
         LDY   #$0010
         PHA
         TXA
         STA   [$FD],Y
         PLA
         LDY   #$000E
         STA   [$FD],Y
         BRA   L015FBD
L015F77  LDY   #$000C
         LDA   [$FD],Y
         SEC
         SBC   #$0000
         BEQ   L015FBD
         BVS   L015F87
         EOR   #$8000
L015F87  BPL   L015FBD
         PEA   $0001
         LDY   #$0004
         LDA   [$FD],Y
         EOR   #$FFFF
         INC
         LDX   #$0000
         TAY
         BPL   L015F9C
         DEX
L015F9C  PHX
         PHA
         LDY   #$000C
         LDA   [$FD],Y
         PHA
         JSL   L015418
         PLY
         PLY
         PLY
         PLY
         PHX
         PHA
         PLA
         PLX
         LDY   #$0010
         PHA
         TXA
         STA   [$FD],Y
         PLA
         LDY   #$000E
         STA   [$FD],Y
L015FBD  LDY   #$0008
         LDA   [$FD],Y
         TAX
         LDY   #$0006
         LDA   [$FD],Y
         PHX
         PHA
         PLA
         PLX
         LDY   #$0002
         PHA
         TXA
         STA   [$FD],Y
         PLA
         STA   [$FD]
         LDA   #$0000
         LDY   #$0004
         STA   [$FD],Y
         LDA   #$0000
L015FE1  TAY
         TDC
         CLC
         ADC   #$00F7
         TCS
         TYA
         PLD
         RTL

*-----------------------------------
* SUBTRACT 32-BIT A/X
*-----------------------------------

subtract32AX
         SEC
         SBC   $04,S
         STA   $04,S
         TXA
         SBC   $06,S
         STA   $06,S
         RTL

*-----------------------------------
* COPY N BYTES
*-----------------------------------

copyBYTES
         PHD
         TSC
         SEC
         SBC   #$00F1
         TCD
         ADC   #$00E8
         TCS
         LDX   $FB
         LDA   $F9
         STX   $EC
         STA   $EA
	ldy   $f7	; number of bytes to copy
L016009  cpy   #$0001
         BEQ   L016036
         BCC   L016036
         LDA   [$FD]
         STA   [$F9]
         LDA   $F9
         CLC
         ADC   #$0002
         STA   $F9
         BCC   L016024
         INC   $FB
L016024  LDA   $FD
         CLC
         ADC   #$0002
         STA   $FD
         BCC   L016030
         INC   $FF
L016030  dey
         dey
         BRA   L016009
L016036  cpy   #0
         BEQ   L016042
         SEP   #$20
         LDA   [$FD]
         STA   [$F9]
         REP   #$20
L016042  LDX   $EC
         LDA   $EA
         STX   $FF
         STA   $FD
         TDC
         CLC
         ADC   #$00F1
         TCS
         PLD
         RTL

*-----------------------------------
* FILE: DESTROY
*-----------------------------------

fileDESTROY
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         LDA   $FD
         LDX   $FF
         PHX
         PHA
         LDA   #L0333D7
         LDX   #^L0333D7
         STA   $F4
         STX   $F6
         PEI   $F6
         PEI   $F4
         PEA   $0008
         JSL   copyBYTES
         PLA
         PLA
         PLA
         PLA
         PLX
         LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         PHX
         PHA
         JSL   L015D49
         PLY
         PLY
         JSL   GSOS
         DW    $0002      ; Destroy
         ADRL  L0333D7
         LDY   #$0002
         LDA   [$FD],Y
         TAX
         LDA   [$FD]
         PHX
         PHA
         JSL   L015DB7
         PLY
         PLY
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*-----------------------------------
*
*-----------------------------------

L0160B2  TSC
         TCD
         LDA   [$04]
         TAX
         LDA   $04,S
         TAY
         LDA   $06,S
         TCD
         LDA   $08,S
         TXS
         PHA
         PHA
         PHD
         PHY
         TSC
         TCD
         LDY   #$0002
         LDA   [$01],Y
         TAX
         INY
         INY
         LDA   [$01],Y
         STA   $08,S
         INY
         INY
         LDA   [$01],Y
         STA   $0A,S
         PLA
         PLA
         PLA
         PLY
         CMP   #$0000
         BNE   L0160E2
         INC
L0160E2  PHX
         PLD
         RTL

*-----------------------------------
* FIND AND DISPOSE HANDLE
*-----------------------------------
*
* $FD: long - pointer whose handle to be found and disposed

findDISPOSEHANDLE
         PHD
         TSC
         SEC
         SBC   #$00F7
         TCD
         ADC   #$00F2
         TCS
         PHX
         PHA
         PEI   $FF
         PEI   $FD
         _FindHandle
         _DisposeHandle
         TDC
         CLC
         ADC   #$00F7
         TCS
         PLD
         RTL

*--------------------------

	put	MIDI.S
	put	GLOBALS.S
	put	ARRAYS.S
